/*
 ķ
   Program..: _DCCXP.PRG                                   
   Author...:  Roger J. Donnay                             
   Notice...: (c) DONNAY Software Designs 1987-2003        
   Date.....: Jun 17, 2003                                 
   Notes....: eXPress++ HTML Functions and Classes         
 Ľ
*/


#include "dcdialog.ch"
#include "dccxp.ch"
#include "gra.ch"

#ifndef CRLF
  #define CRLF   Chr(13)+Chr(10)
#endif

FUNCTION DC_ReadHtml ( aGetList, cTitle, oParent, cRootDir, oHtmlMain, ;
                       aMessageInto, lHTMLTag )

LOCAL i, j, aHtml, oHtml, bBlock, nType, cHtml, nPointer, ;
      nStartRow, nStartCol, xCargo, aGetListItem, oSetParent, xParent, ;
      oHtmlOptions

IF oHtmlMain == nil

  DEFAULT cRootDir := ''

  oHtmlOptions := DC_HtmlOptions():new()
  IF !Empty(cRootDir)
    oHtmlOptions:rootDir := cRootDir
  ENDIF
  oHtmlOptions:messageInto := aMessageInto

  FOR i := 1 TO Len(aGetList)

    aGetListItem := aGetList[i]
    nType := aGetListItem[nGETLIST_TYPE]
    oParent := nil
    IF Valtype(xParent := aGetListItem[bGETLIST_PARENT]) = 'C' .AND. !(xParent[1] $ '{') // it's an ID
      oParent := DC_GetObject(aGetList,xParent)
    ELSE
      bBlock := DC_GetBlock(xParent,'O')
      IF Valtype(bBlock) = 'B'
        oParent := Eval( bBlock )
      ENDIF
    ENDIF
    IF oParent == NIL .AND. Valtype(oSetParent) = 'O'
      oParent := oSetParent
    ENDIF

    IF nType == GETLIST_HTMLMAIN
      oHtml := DC_HtmlMain():new( oParent, aGetListItem )
    ELSEIF nType == GETLIST_SAY
      oHtml := DC_HtmlSay():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_GET
      oHtml := DC_HtmlGet():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_CHECKBOX
      oHtml := DC_HtmlCheckBox():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLLIST
      oHtml := DC_HtmlList():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_COMBOBOX
      oHtml := DC_HtmlComboBox():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_MLE
      oHtml := DC_HtmlMle():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_RADIOBUTTON
      oHtml := DC_HtmlRadioButton():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLSUBMIT
      oHtml := DC_HtmlSubmit():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_BROWSE
      oHtml := DC_HtmlBrowse():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_BROWSECOL
      oHtml := DC_HtmlColumn():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLTABLE
      oHtml := DC_HtmlTable():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLTABGROUP
      oHtml := DC_HtmlTabGroup():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLFORM
      oHtml := DC_HtmlForm():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLTAG
      oHtml := DC_HtmlTag():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLFRAMESET
      oHtml := DC_HtmlFrameSet():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLFRAME
      oHtml := DC_HtmlFrame():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTML
      oHtml := DC_Html():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLINPUT
      oHtml := DC_HtmlInput():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLLINK
      oHtml := DC_HtmlLink():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLHYPERLINK
      oHtml := DC_HtmlHyperLink():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLIMAGE
      oHtml := DC_HtmlImage():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLVARS
      oHtml := DC_HtmlVars():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLBODY
      oHtml := DC_HtmlBody():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLDIV
      oHtml := DC_HtmlDiv():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLMENUBAR
      oHtml := DC_HtmlMenuBar():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLSUBMENU
      oHtml := DC_HtmlSubMenu():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_HTMLMENUITEM
      oHtml := DC_HtmlMenuItem():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_EVAL
      IF Valtype(aGetListItem[bGETLIST_WHEN]) # 'B' .OR. ;
         Eval(aGetListItem[bGETLIST_WHEN])
        Eval(aGetListItem[bGETLIST_EVAL])
      ENDIF
      LOOP
    ELSEIF nType == GETLIST_SETPARENT
      oSetParent := nil
      xParent := aGetListItem[bGETLIST_PARENT]
      IF Valtype(xParent) == 'C' .AND. !(xParent[1]=='{') // it's an ID
        oSetParent := DC_GetObject(aGetList,xParent)
      ELSE
        bBlock := DC_GetBlock(xParent,'O')
        IF Valtype( bBlock ) = 'B'
          oSetParent := Eval( bBlock )
        ENDIF
      ENDIF
      LOOP
    ELSE
      LOOP
    ENDIF

    oHtml:options := oHtmlOptions
    oHtml:getList := aGetList
    oHtml:getListPointer := i

    nPointer := aGetListItem[nGETLIST_POINTER]
    IF Valtype(oHtml:startCol) # 'N' .AND. Valtype(nPointer) = 'N' .AND. nType # GETLIST_BROWSECOL
      oHtml:startCol := aGetList[nPointer,nGETLIST_STARTCOL]
    ENDIF
    IF Valtype(oHtml:startRow) # 'N' .AND. Valtype(nPointer) = 'N' .AND. nType # GETLIST_BROWSECOL
      oHtml:startRow := aGetList[nPointer,nGETLIST_STARTROW]
    ENDIF

    //  aGetListItem[bGETLIST_PARENT] := oParent

    IF oHtmlMain == NIL
      IF oHtml:isDerivedFrom('DC_HtmlMain')
        oHtmlMain := oHtml
      ELSE
        oHtmlMain := DC_HtmlMain():new()
      ENDIF
    ENDIF

    IF oParent == NIL .AND. Valtype(oHtmlMain) == 'O' .AND. !(oHtml:isDerivedFrom('DC_HtmlMain'))
      AAdd(oHtmlMain:childList,oHtml)
    ENDIF

    aGetListItem[oGETLIST_OBJECT] := oHtml

    bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
    IF Valtype( bBlock ) = 'B'
      Eval( bBlock, oHtml )
    ENDIF

    bBlock := DC_GetBlock(aGetListItem[bGETLIST_EVAL],'O')
    IF Valtype( bBlock ) = 'B'
      Eval( bBlock, oHtml )
    ENDIF

  NEXT

ENDIF

cHtml := oHtmlMain:writeHtml(nil,nil,nil,lHtmlTag)

RETURN cHtml

* --------------

CLASS DC_HtmlOptions

EXPORTED:

  CLASS VAR rootDir
  CLASS VAR messageInto

INLINE METHOD Init()
::rootDir := DC_CurPath() + '\'

RETURN self

ENDCLASS

* ------------

CLASS DC_Html

EXPORTED:

  VAR htmlText
  VAR fgcolor
  VAR bgcolor
  VAR style
  VAR startrow
  VAR startcol
  VAR childList
  VAR parent
  VAR cargo
  VAR varName
  VAR dataLink
  VAR border
  VAR preHtmlText
  VAR postHtmlText
  VAR options
  VAR hideBlock
  VAR whenBlock
  VAR toolTip
  VAR message
  VAR rowSpan
  VAR colSpan
  VAR align
  VAR noWrap
  VAR borderColor
  VAR valign
  VAR height
  VAR width
  VAR heading
  VAR footing
  VAR getList
  VAR getListPointer
  VAR _class
  VAR cellWidth
  VAR cellHeight
  VAR dir
  VAR lang
  VAR title
  VAR optionArray
  VAR TDoptionArray
  VAR TRoptionArray

  INLINE METHOD Init( oParent, aGetListItem )
  LOCAL xColor, aSpan

  ::htmlText := aGetListItem[cGETLIST_CAPTION]
  xColor := aGetListItem[aGETLIST_COLOR]

  IF Valtype(xColor) == 'B'
    ::bgColor := xColor
  ELSEIF Valtype(xColor) == 'A' .AND. Valtype(xColor[1]) == 'B'
    ::bgColor := xColor[1]
  ELSE
    xColor := DC_XbpToHtmlColor(xColor)
    IF Valtype(xColor) == 'A'
      ::fgColor := xColor[1]
      ::bgColor := xColor[2]
    ELSEIF Valtype(xColor) == 'C'
      ::bgColor := xColor
    ENDIF
  ENDIF

  ::style := DC_XbpToHtmlFont(aGetListItem[cGETLIST_FONT])
  ::width := aGetListItem[nGETLIST_WIDTH]
  ::height := aGetListItem[nGETLIST_HEIGHT]
  ::childList := {}
  ::parent := oParent
  ::varName := ''
  ::border := 0
  ::varName := _VarName(aGetListItem)
  ::dataLink := aGetListItem[bGETLIST_VAR]
  ::startRow := aGetListItem[nGETLIST_STARTROW]
  ::startCol := aGetListItem[nGETLIST_STARTCOL]
  ::preHtmlText := aGetListItem[bGETLIST_PREEVAL]
  ::postHtmlText := aGetListItem[bGETLIST_POSTEVAL]
  ::hideBlock := aGetListItem[bGETLIST_HIDE]
  ::whenBlock := aGetListItem[bGETLIST_WHEN]
  ::toolTip := aGetListItem[cGETLIST_TOOLTIP]
  ::message := aGetListItem[cGETLIST_MESSAGE]
  ::title := aGetListItem[cGETLIST_TITLE]
  ::_class := aGetListItem[bGETLIST_CLASS]
  aSpan := aGetListItem[xGETLIST_OPTIONS8]
  IF Valtype(aSpan) == 'A'
    IF Valtype(aSpan[1]) == 'N'
      ::colSpan := aSpan[1]
    ENDIF
    IF Valtype(aSpan[2]) == 'N'
      ::rowSpan := aSpan[2]
    ENDIF
  ENDIF

  ::optionArray := aGetListItem[xGETLIST_OPTIONS7]
  ::TDoptionArray := aGetListItem[xGETLIST_OPTIONS9]
  ::TRoptionArray := aGetListItem[xGETLIST_OPTIONS6]

  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
  ENDIF

  RETURN self

  INLINE METHOD WriteHtml( nLevel, xParam1, xParam2 )

  LOCAL i, cHtml := '', cMessageInto, aFont, cText, cPre, cPost
  DEFAULT nLevel := 0

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText, xParam1, xParam2 )
  cPost := _GetData(::postHtmlText, xParam1, xParam2 )
  aFont := _FormatFont(::style)

  IF Valtype(::options) == 'O'
    cMessageInto := ::options:messageInto
  ENDIF

  cText := _Caption(::htmlText,,,::toolTip,::message,cMessageInto,,.f.)

  // cHtml := Space(nLevel*3) + cPre + aFont[1] + cText // + CRLF

  cHtml := cPre + aFont[1] + cText // + CRLF

  FOR i := 1 TO Len(::childList)
    cHtml += ::childList[i]:WriteHtml( nLevel + 1 )
  NEXT

  cHtml += aFont[2] + cPost // + CRLF

  RETURN cHtml

  INLINE METHOD ChildList()
  RETURN ::childList

  INLINE METHOD Status()
  RETURN 1

ENDCLASS

* ------------

CLASS DC_HtmlMain FROM DC_Html

EXPORTED:

  INLINE METHOD Init( oParent, aGetListItem )
  LOCAL xColor, bBlock, cPre, cPost

  IF !Empty(aGetListItem)
    ::DC_Html:init( nil, aGetListItem )
    ::style := aGetListItem[cGETLIST_FONT]
  ELSE
    ::childList := {}
  ENDIF
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
  ENDIF

  RETURN self

  INLINE METHOD WriteHtml( nLevel, xParam1, xParam2, lHtmlTag )

  LOCAL i, cHtml := '', cStyle, cPre, cPost
  DEFAULT nLevel := 0, ;
          lHtmlTag := .F.

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText, xParam1, xParam2 )
  cPost := _GetData(::postHtmlText, xParam1, xParam2 )
  cStyle := _GetData(::style)

  cHtml += cPre + IIF(lHtmlTag,'<html>' + CRLF,'')

  IF !Empty(cStyle)
    cHtml += MemoRead(cStyle)
  ENDIF

  FOR i := 1 TO Len(::childList)
    cHtml += ::childList[i]:WriteHtml( nLevel )
  NEXT

  cHtml += IIF( lHtmlTag,'</html>' + CRLF,'' ) + cPost

  RETURN cHtml

ENDCLASS

* ------------

CLASS DC_HtmlBody FROM DC_Html

EXPORTED:

  VAR link
  VAR alink
  VAR vlink
  VAR topMargin
  VAR leftMargin
  VAR background
  VAR bgProperties
  VAR onLoad
  VAR onUnload
  VAR textColor

  INLINE METHOD Init( oParent, aGetListItem )
  LOCAL xOptions

  ::DC_Html:init( nil, aGetListItem )
  ::onLoad := aGetListItem[xGETLIST_OPTIONS3]
  ::onUnload := aGetListItem[xGETLIST_OPTIONS4]
  ::style := aGetListItem[cGETLIST_FONT]
  xOptions := aGetListItem[xGETLIST_OPTIONS]
  DEFAULT xOptions := {}
  ASize(xOptions,9)
  ::link := xOptions[1]
  ::vlink := xOptions[2]
  ::alink := xOptions[3]
  ::bgColor := xOptions[4]
  ::bgProperties := xOptions[5]
  ::leftMargin := xOptions[6]
  ::topMargin := xOptions[7]
  ::backGround := xOptions[8]
  ::textColor := xOptions[9]
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF

  RETURN self

  INLINE METHOD WriteHtml( nLevel, xParam1, xParam2 )

  LOCAL i, cHtml := '', cLink, cAlink, cVlink, cBGColor, cBGProperties, ;
        cBackGround, cTextColor, cStyle, cOnLoad, cOnUnload, cPre, cPost, ;
        cClass

  DEFAULT nLevel := 0

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText,xParam1,xParam2)
  cPost := _GetData(::postHtmlText,xParam1,xParam2)
  cOnload := _GetData(::onLoad,xParam1,xParam2)
  cOnUnload := _GetData(::onUnload,xParam1,xParam2)
  cStyle := _GetData(::style,xParam1,xParam2)
  cLink := _GetData(::link,xParam1,xParam2)
  cVLink := _GetData(::vlink,xParam1,xParam2)
  cALink := _GetData(::alink,xParam1,xParam2)
  cBGColor := _GetData(::bgColor,xParam1,xParam2)
  cBGProperties := _GetData(::bgProperties,xParam1,xParam2)
  cBackGround := _GetData(::backGround,xParam1,xParam2)
  cTextColor := _GetData(::textColor,xParam1,xParam2)
  cClass := _GetData(::_class)

  cHtml += cPre + '<body' + ;
    IIF(!Empty(cOnLoad),' onload="' + cOnLoad + '"','') + ;
    IIF(!Empty(cOnUnload),' onunload="' + cOnUnload + '"','') + ;
    IIF(!Empty(cLink),' link=' + cLink,'') + ;
    IIF(!Empty(cALink),' alink=' + cALink,'') + ;
    IIF(!Empty(cVLink),' vlink=' + cVLink,'') + ;
    IIF(!Empty(cBGColor),' bgcolor=' + cBGColor,'') + ;
    IIF(!Empty(cBGProperties),' bgproperties=' + cBGProperties,'') + ;
    IIF(::leftMargin#nil,' leftmargin=' + _GetData(::leftMargin),'') + ;
    IIF(::topMargin#nil,' topmargin=' + _GetData(::topMargin),'') + ;
    IIF(!Empty(cBackGround),' background="' + cBackGround + '"','') + ;
    IIF(!Empty(cTextColor),' text="' + cTextColor + '"','') + ;
    IIF(!Empty(cClass),' class="' + cClass + '"','') + ;
    '>' + CRLF

  IF !Empty(cStyle)
    cHtml += MemoRead(cStyle)
  ENDIF

  FOR i := 1 TO Len(::childList)
    cHtml += ::childList[i]:WriteHtml( nLevel )
  NEXT
  cHtml += '</body>' + CRLF + cPost

  RETURN cHtml

ENDCLASS

* ------------

CLASS DC_HtmlVars FROM DC_Html

EXPORTED:

  VAR include
  VAR exclude
  VAR sysVars

INLINE METHOD Init( oParent, aGetListItem )

  ::sysVars := aGetListItem[bGETLIST_REFVAR]
  ::include := aGetListItem[xGETLIST_OPTIONS2]
  ::exclude := aGetListItem[xGETLIST_OPTIONS3]
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel, xParam1, xParam2 )

  LOCAL i, cHtml := '', oThread, aVars[0], aSysVars, aInclude, ;
        aExclude, nFound

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  DEFAULT nLevel := 0

  aSysVars := _GetData(::sysVars,xParam1,xParam2)
  aInclude := _GetData(::include,xParam1,xParam2)
  aExclude := _GetData(::exclude,xParam1,xParam2)

  DEFAULT aInclude := {}, ;
          aExclude := {}

  IF Valtype(aSysVars) == 'A'
    FOR i := 1 TO Len(aSysVars)
      IF ( nFound := AScan(aVars,{|a|a[1]==aSysVars[i,1]}) ) > 0
        ARemove(aVars,nFound)
      ENDIF
      AAdd(aVars,aSysVars[i])
    NEXT
  ENDIF

  IF !Empty(aInclude)
    FOR i := 1 TO Len(aInclude)
      IF ( nFound := AScan(aVars,{|a|a[1]==aInclude[i,1]}) ) > 0
        ARemove(aVars,nFound)
      ENDIF
      AAdd(aVars,aINclude[i])
    NEXT
  ENDIF

  FOR i := 1 TO Len(aVars)

    IF ( nFound := AScan(aExclude,aVars[i,1]) ) > 0
      LOOP
    ELSEIF _Exclude( aVars[i,1], aExclude )
      LOOP
    ENDIF

    cHtml += Space(nLevel*3) + ;
             '<input type=hidden name="' + aVars[i,1] + '"' + ;
             ' value="' + Strtran(DC_Xtoc(aVars[i,2]),'"','&quot;') + '">' + CRLF
  NEXT

  RETURN cHtml

ENDCLASS

* ----------------

STATIC FUNCTION _Exclude( cVarName, aExclude )

LOCAL i

FOR i := 1 TO Len(aExclude)
  IF DC_WildCardMatch( cVarName, aExclude[i] )
    RETURN .t.
  ENDIF
NEXT

RETURN .f.

* ----------------

FUNCTION DC_WildCardMatch( cString, cWildCard )

LOCAL i, j, cStringChar, cWildChar, cNextWildChar

IF !('*'$cWildCard)
  IF cString == cWildCard
    RETURN .t.
  ELSE
    RETURN .f.
  ENDIF
ENDIF

j := 1
FOR i := 1 TO Len(cString)
  cStringChar := cString[i]
  cWildChar := cWildCard[j]
  j++
  IF cStringChar # cWildChar .AND. cWildChar # '*'
    RETURN .f.
  ELSEIF cWildChar == '*'
    IF j >= Len(cWildCard)
      RETURN .t.
    ENDIF
    cNextWildChar := cWildCard[j]
    DO WHILE cStringChar # cNextWildChar
      i++
      IF i > Len(cString)
        IF cNextWildChar = '*'
          RETURN .t.
        ELSE
          RETURN .f.
        ENDIF
      ENDIF
      cStringChar := cString[i]
    ENDDO
    j++
  ENDIF
NEXT

RETURN .t.

* -------------

CLASS DC_HtmlTable FROM DC_Html

EXPORTED:

VAR tableTrimColumns
VAR tableTrimRows
VAR tableRows
VAR tableColumns
VAR tableBorder
VAR tableFill
VAR tableWidth
VAR tableHeaders
VAR tableFooters
VAR tableClass
VAR tableStyle
VAR tableTRClass
VAR tableTDClass
VAR tableTHClass
VAR tableTRStyle
VAR tableTDStyle
VAR tableTHStyle

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL xOptions := aGetListItem[xGETLIST_OPTIONS]
  DEFAULT xOptions := {}
  ASize(xOptions,12)
  DEFAULT xOptions[1] := .f., ;
          xOptions[2] := .f.
  ::DC_Html:Init( nil, aGetListItem )
  ::tableRows := aGetListItem[xGETLIST_OPTIONS2]
  ::tableColumns := aGetListItem[xGETLIST_OPTIONS3]
  ::tableBorder := aGetListItem[xGETLIST_OPTIONS4]
  ::tableTrimRows := xOptions[1]
  ::tableTrimColumns := xOptions[2]
  ::tableClass := aGetListItem[bGETLIST_CLASS]
  ::tableStyle := aGetListItem[cGETLIST_FONT]
  ::tableWidth := xOptions[3]
  ::tableFill := xOptions[4]
  ::dir := xoptions[5]
  ::lang := xoptions[6]
  ::tableTRClass := xOptions[7]
  ::tableTDClass := xOptions[8]
  ::tableTHClass := xOptions[9]
  ::tableTRStyle := xOptions[10]
  ::tableTDStyle := xOptions[11]
  ::tableTHStyle := xOptions[12]

  DEFAULT ::tableRows := 0, ;
          ::tableColumns := 0

  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel, xParam1, xParam2 )

  LOCAL i, j, k, l, cHtml := '', aTable, aColSpan, aRowSpan, cTD, ;
        nRows, nCols, cAlign := '', cVAlign, aHeader[0], aFooter[0], ;
        cBorder, cFill, aClass, aWidth, aNoWrap, nRow, nCol, ;
        cTableWidth, cPre, cPost, cClass, aOptions, aStyle, ;
        aTHOptions, aTFOptions, aTROptions

  IF Empty(nLevel)
    nLevel := 1
  ENDIF

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cFill := _GetData(::tableFill,xParam1,xParam2)
  cPre := _GetData(::preHtmlText,xParam1,xParam2)
  cPost := _GetData(::postHtmlText,xParam1,xParam2)
  aTable := Array(::tableRows,::tableColumns)
  aColSpan := Array(::tablerows,::tablecolumns)
  aRowSpan := Array(::tablerows,::tablecolumns)
  aClass := Array(::tablerows,::tablecolumns)
  aStyle := Array(::tablerows,::tablecolumns)
  aNoWrap := Array(::tablerows,::tablecolumns)
  aWidth := Array(::tablerows,::tablecolumns)
  aOptions := Array(::tablerows,::tablecolumns)
  aTHOptions := Array(::tablerows)
  aTFOptions := Array(::tablerows)
  aTROptions := Array(::tablerows)

  FOR i := 1 TO ::tableRows
    AFill(aTable[i], cFill)
  NEXT i

  FOR i := 1 TO Len(::childList)

    IF ::childList[i]:startRow == DCHTML_TABLE_HEADER

      ASize(aHeader,Max(Len(aHeader),::childList[i]:startCol))
      DEFAULT aHeader[::childList[i]:startCol] := ''
      aHeader[::childlist[i]:startCol] += ;
        ::childList[i]:WriteHtml( nLevel + 1 )

      nCol := ::childList[i]:startCol
      _AStuff(@aTHOptions[nCol],::childList[i]:TDoptionArray)

    ELSEIF ::childList[i]:startRow == DCHTML_TABLE_FOOTER

      ASize(aFooter,Max(Len(aFooter),::childList[i]:startCol))
      DEFAULT aFooter[::childList[i]:startCol] := ''
      aFooter[::childlist[i]:startCol] += ;
        ::childList[i]:WriteHtml( nLevel + 1 )

      nCol := ::childList[i]:startCol
      _AStuff(@aTFOptions[nCol],::childList[i]:TDoptionArray)

    ELSEIF ::childList[i]:startRow > 0 .AND. ::childList[i]:startRow <= ::tableRows .AND. ;
           ::childList[i]:startCol > 0 .AND. ::childList[i]:startCol <= ::tableColumns

      nRow := ::childList[i]:startRow
      nCol := ::childList[i]:startCol

      aTable[nRow,nCol] += ::childList[i]:WriteHtml( nLevel + 2 )

      _AStuff(@aColSpan[nRow,nCol],::childList[i]:colSpan)
      _AStuff(@aRowSpan[nRow,nCol],::childList[i]:rowSpan)
      _AStuff(@aClass[nRow,nCol],::childList[i]:_class)
      _AStuff(@aNoWrap[nRow,nCol],::childList[i]:noWrap)
      _AStuff(@aWidth[nRow,nCol],::childList[i]:cellWidth)
      _AStuff(@aOptions[nRow,nCol],::childList[i]:TDoptionArray)
      _AStuff(@aStyle[nRow,nCol],::childList[i]:style)
      _AStuff(@aTROptions[nRow],::childList[i]:TRoptionArray)

    ENDIF

  NEXT

  cHtml += Space(nLevel) + ;
    cPre + '<table' + ;
    _OptionNil(::tableClass,'class') + ;
    _OptionNil(::tableStyle,'style') + ;
    _OptionNil(::tableWidth,'width') + ;
    _OptionNil(::tableBorder,'border') + ;
    _OptionNil(::optionArray) + ;
    '>' + CRLF

  IF ::tableTrimRows
    nRows := _TrimRows(aTable)
  ELSE
    nRows := ::tableRows
  ENDIF

  IF !Empty(aHeader)
    cHtml += Space(nLevel+1) + '<tr ' + ;
      _OptionNil(::tableTRClass,'class') + ;
      '>' + CRLF
    IF ::tableTrimColumns
      nCols := _TrimCols(aHeader)
    ELSE
      nCols := ::tableColumns
    ENDIF
    FOR j := 1 TO nCols
      cHtml += Space(nLevel+1) + ' <th ' + ;
        _OptionNil(::tableTHClass,'class') + ;
        _OptionNil(::tableTHStyle,'style') + ;
        _OptionNil(aTHOptions[j]) + ;
         '>' + aHeader[j] + '</th>' + CRLF
    NEXT j
    cHtml += Space(nLevel+1) + '</tr>' + CRLF
  ENDIF

  FOR i := 1 TO nRows
    IF ::tableTrimColumns
      nCols := _TrimCols(aTable[i])
    ELSE
      nCols := ::tableColumns
    ENDIF
    FOR j := 1 TO nCols
      IF !Empty(aRowSpan[i,j])
        FOR k := 1 TO aRowSpan[i,j] -1
          FOR l := 1 TO aColSpan[i,j]
            aColSpan[i+k,j+l-1] := -1
          NEXT
        NEXT
      ENDIF
    NEXT
  NEXT

  FOR i := 1 TO nRows
    cHtml += Space(nLevel+1) + '<tr ' + ;
      _OptionNil(::tableTRClass,'class') + ;
      _OptionNil(aTROptions[i]) + ;
       + '>' + CRLF
    IF ::tableTrimColumns
      nCols := _TrimCols(aTable[i])
    ELSE
      nCols := ::tableColumns
    ENDIF

    FOR j := 1 TO nCols

      IF !Empty(aColSpan[i,j]) .AND. aColSpan[i,j] == -1
        LOOP
      ENDIF

      cTD := Space(nLevel+2) + '<td' + ;
      _OptionNil(::tableTDClass,'class') + ;
      _OptionNil(::tableTDStyle,'style') + ;
      _OptionNil(aOptions[i,j]) + ;
      _OptionEmpty(aColSpan[i,j],'colspan') + ;
      _OptionEmpty(aRowSpan[i,j],'rowspan') + ;
      _OptionEmpty(aWidth[i,j],'width') + ;
      _OptionEmpty(aClass[i,j],'class') + ;
      _OptionEmpty(aStyle[i,j],'style') + ;
      IIF(!Empty(aNoWrap[i,j]),' nowrap','') + ;
      '>'

      IF aTable[i,j] == nil
        cHtml += cTD + Space(nLevel+2) + '</td>' + CRLF
      ELSE
        cHtml += cTD + CRLF + ;
                 aTable[i,j] + Space(nLevel+2) + '</td>' + CRLF
      ENDIF

      IF !Empty(aColSpan[i,j])
        j += aColSpan[i,j] - 1
      ENDIF

    NEXT j
    cHtml += Space(nLevel+1) + '</tr>' + CRLF

  NEXT i

  IF !Empty(aFooter)
    cHtml += Space(nLevel+1) + ' <tr>' + CRLF
    IF ::tableTrimColumns
      nCols := _TrimCols(aFooter)
    ELSE
      nCols := ::tableColumns
    ENDIF
    FOR j := 1 TO nCols
      cHtml += Space(nLevel+1) + ' <th ' + ;
        _OptionNil(::tableTHClass,'class') + ;
        _OptionNil(::tableTHStyle,'style') + ;
        _OptionNil(aTFOptions[j]) + ;
         '>' + aFooter[j] + '</th>' + CRLF
    NEXT j
    cHtml += Space(nLevel+1) + '</tr>' + CRLF
  ENDIF

  cHtml += Space(nLevel) + '</table>' + cPost + CRLF

  RETURN cHtml

ENDCLASS

* ----------------

CLASS DC_HtmlTabGroup FROM DC_HtmlTable

EXPORTED:

VAR tabCount
VAR tabSelected
VAR tabName
VAR tabCaptions
VAR tabColorUnselected
VAR tabColorSelected
VAR tabObject

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL bBlock, xOptions := AClone(aGetListItem[xGETLIST_OPTIONS])
  DEFAULT xOptions := {}
  ASize(xOptions,12)

  ::DC_HtmlTable:Init( nil, aGetListItem )

  ::tabCount := aGetListItem[xGETLIST_OPTIONS2]
  ::tabSelected := aGetListItem[xGETLIST_OPTIONS4]
  ::tableAlign := xOptions[1]
  ::tableBorder := aGetListItem[nGETLIST_SUBTYPE]
  ::tableBorderColor := xOptions[2]
  ::tableBorderColorLight := xOptions[3]
  ::tableBorderColorDark := xOptions[4]
  ::tableCellPadding := xOptions[5]
  ::tableCellSpacing := xOptions[6]
  ::tableHSpace := xOptions[7]
  ::tableVAlign := xOptions[8]
  ::tableVSpace := xOptions[9]
  ::tableWidth := xOptions[10]
  ::tabColorSelected := xOptions[11]
  ::tabColorUnSelected := xOptions[12]
  ::tabCaptions := aGetListItem[xGETLIST_OPTIONS2]
  ::tabName := aGetListItem[xGETLIST_OPTIONS3]
  ::tabObject := DC_HtmlChild():new()

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])
  IF Valtype(bBlock) = 'B'
    Eval(bBlock,::tabObject)
  ENDIF

  DEFAULT ::tableWidth := '100%', ;
          ::tabCount := 0, ;
          ::tabName := 'DCHTML_TabGroup'

  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL i, cHtml := '', aTabs[::tabCount], cData := '', ;
        cAlign := '', cVAlign, cBorder, nTabSelected, cPre, cPost

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  DEFAULT nLevel := 0

  IF Valtype(::tabSelected) == 'B'
    nTabSelected := Eval(::tabSelected)
  ELSEIF Valtype(::tabSelected) == 'N'
    nTabSelected := ::tabSelected
  ELSE
    nTabSelected := 1
  ENDIF

  cBorder := _GetData(::tableBorder)
  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)

  DEFAULT ::tableAlign := 0, ;
          ::tableVAlign := 0

  IF ::tableAlign == DCHTML_ALIGN_RIGHT
    cAlign := 'right'
  ELSEIF ::tableAlign == DCHTML_ALIGN_LEFT
    cAlign := 'left'
  ENDIF
  IF ::tableVAlign == DCHTML_ALIGN_TOP
    cVAlign := 'top'
  ELSEIF ::tableVAlign == DCHTML_ALIGN_BOTTOM
    cVAlign := 'bottom'
  ENDIF

  AFill(aTabs,'')

  FOR i := 1 TO Len(::tabObject:childList)
    aTabs[i] := ::tabObject:childList[i]:writeHtml(nLevel+1,IIF(i==nTabSelected,1,2))
    IF Empty(aTabs[i]) .AND. IsMemberVar('CAPTION',::childList[i])
      aTabs[i] := ::childList[i]:caption
    ENDIF
  NEXT

  cData := ::childList[nTabSelected]:writeHtml( nLevel + 1 )

  cHtml += Space(nLevel*3) + ;
    cPre + '<table' + ;
    IIF(!(::tableWidth==nil),' width=' + _GetData(::tableWidth),'') + ;
    IIF(!Empty(cBorder),' border=' + Alltrim(cBorder),'') + ;
    IIF(!(::bgColor==nil),' bgcolor=' + DC_XbpToHtmlColor(::bgColor),'') + ;
    IIF(!Empty(cAlign),' align ' + cAlign,'') + ;
    IIF(!Empty(cVAlign),' valign ' + cVAlign,'') + ;
    IIF(!(::tableBorderColor==nil),' bordercolor=' + DC_XbpToHtmlColor(::tableBorderColor),'') + ;
    IIF(!(::tableBorderColorLight==nil),' bordercolorlight=' + DC_XbpToHtmlColor(::tableBorderColorLight),'') + ;
    IIF(!(::tableBorderColorDark==nil),' bordercolordark=' + DC_XbpToHtmlColor(::tableBorderColorDark),'') + ;
    IIF(!(::tableCellPadding==nil),' cellpadding=' + Alltrim(_GetData(::tableCellPadding)),'') + ;
    IIF(!(::tableCellSpacing==nil),' cellspacing=' + Alltrim(_GetData(::tableCellSpacing)),'') + ;
    IIF(!(::tableHSpace==nil),' hspace=' + Alltrim(_GetData(::tableHSpace)),'') + ;
    IIF(!(::tableVAlign==nil),' valign=' + Alltrim(_GetData(::tableVAlign)),'') + ;
    IIF(!(::tableVSpace==nil),' vspace=' + Alltrim(_GetData(::tableVSpace)),'') + ;
    _OptionNil(::optionArray) + ;
    '>' + CRLF

  cHtml += Space(nLevel*3) + ' <tr>' + CRLF

  FOR i := 1 TO ::tabCount
    cHtml += Space(nLevel*3) + '<th' + ;
             iif(!(::tabColorSelected==nil) .AND. i == nTabSelected,' bgcolor=' + DC_XbpToHtmlColor(::tabColorSelected),'') + ;
             iif(!(::tabColorUnSelected==nil) .AND. i # nTabSelected,' bgcolor=' + DC_XbpToHtmlColor(::tabColorUnSelected),'') + ;
             '>' + CRLF + Space(nLevel*3) + aTabs[i] + Space(nLevel*3) + '</th>' + CRLF
  NEXT
  cHtml += Space(nLevel*3) + '</tr>' + CRLF
  cHtml += Space(nLevel*3) + ' <tr>' + CRLF
  cHtml += Space(nLevel*3) + '<td colspan=' + Alltrim(Str(::tabCount)) + '>' + CRLF
  cHtml += cData
  cHtml += Space(nLevel*3) + '</td>' + CRLF
  cHtml += Space(nLevel*3) + '</tr>' + CRLF
  cHtml += Space(nLevel*3) + '</table>' + cPost + CRLF

  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlChild

EXPORTED:

  VAR childList

INLINE METHOD Init()

  ::childList := {}

RETURN self

ENDCLASS

* -----------

CLASS DC_HtmlSay FROM DC_Html

EXPORTED:

INLINE METHOD Init( oParent, aGetListItem )
  ::DC_Html:Init( nil, aGetListItem )
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel )
  LOCAL aFont, cPre, cPost, cText, cMessageInto

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)

  IF Valtype(::options) == 'O'
    cMessageInto := ::options:messageInto
  ENDIF

  cText := _Caption(::htmlText,,,::toolTip,::message,cMessageInto)

  RETURN Space(nLevel*3) + cPre + aFont[1] + ;
         cText + ;
        aFont[2] + cPost + CRLF

ENDCLASS

* -----------

CLASS DC_HtmlImage FROM DC_Html

EXPORTED:

  VAR src
  VAR dynsrc
  VAR lowsrc
  VAR alt
  VAR usemap
  VAR _loop
  VAR align
  VAR start
  VAR vspace
  VAR hspace
  VAR controls
  VAR border
  VAR ismap
  VAR onError
  VAR onLoad
  VAR onAbort

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL xOptions
  ::DC_Html:Init( nil, aGetListItem )
  ::_class := aGetListItem[bGETLIST_CLASS]
  xOptions := aGetListItem[xGETLIST_OPTIONS]
  ASize(xOptions,29)
  ::src := xOptions[1]
  ::dynsrc := xOptions[2]
  ::lowsrc := xOptions[3]
  ::alt := xOptions[4]
  ::usemap := xOptions[5]
  ::_loop := xOptions[6]
  ::align := xOptions[7]
  ::start := xOptions[8]
  ::vspace := xOptions[9]
  ::hspace := xOptions[10]
  ::controls := xOptions[11]
  ::border := xOptions[12]
  ::ismap := xOptions[13]
  ::dir := xOptions[14]
  ::lang := xOptions[15]

  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL cHtml := '', cSrc, cDynSrc, cLowSrc, cAlt, cUseMap, cLoop, ;
        cAlign, cStart, cVspace, cHspace, cControls, cBorder, cPre, ;
        cWidth, cHeight, cPost, lWhen

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  cSrc := _GetData(::src)
  cDynSrc := _GetData(::dynsrc)
  cLowSrc := _GetData(::lowsrc)
  cAlt := _GetData(::alt)
  cUseMap := _GetData(::usemap)
  cLoop := _GetData(::_loop)
  cAlign := _GetData(::align)
  cStart := _GetData(::start)
  cVspace := _GetData(::vspace)
  cHspace := _GetData(::hspace)
  cControls := _GetData(::controls)
  cBorder := _GetData(::border)
  cWidth := _GetData(::width)
  cHeight := _GetData(::height)

  IF Valtype(::whenBlock) == 'B' .AND. Valtype(cSrc) == 'A'
    lWhen := Eval(::whenBlock)
    IF lWhen
      cSrc := cSrc[1]
    ELSE
      cSrc := cSrc[2]
    ENDIF
  ELSEIF Valtype(cSrc) == 'A'
    cSrc := cSrc[1]
  ENDIF

  cHtml += Space(nLevel*3) + cPre + '<img' + ;
           IIF(!Empty(cSrc),' src="' + cSrc + '"','') + ;
           IIF(!Empty(cDynSrc),' dynsrc="' + cDynSrc + '"','') + ;
           IIF(!Empty(cLowSrc),' lowsrc="' + cLowSrc + '"','') + ;
           IIF(!Empty(cAlt),' alt="' + cAlt + '"','') + ;
           IIF(!Empty(cUseMap),' usemap="' + cUseMap + '"','') + ;
           IIF(!Empty(cLoop),' loop="' + cLoop + '"','') + ;
           IIF(!Empty(cStart),' start="' + cStart + '"','') + ;
           IIF(!Empty(cVspace),' vspace=' + cVspace,'') + ;
           IIF(!Empty(cHspace),' hspace=' + cHspace,'') + ;
           IIF(!Empty(cWidth),' width=' + cWidth,'') + ;
           IIF(!Empty(cHeight),' height=' + cHeight,'') + ;
           IIF(!Empty(cControls),' controls="' + cControls + '"','') + ;
           IIF(!Empty(cBorder),' border="' + cBorder + '"','') + ;
           IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
           IIF(!Empty(::dir),' dir="' + _GetData(::dir) + '"','') + ;
           IIF(!Empty(::lang),' lang="' + _GetData(::lang) + '"','') + ;
           IIF(::ismap,' ismap','') + ;
           _OptionNil(::optionArray) + ;
           '>' + cPost + CRLF

  RETURN  cHtml

ENDCLASS

* -----------

CLASS DC_HtmlHyperLink FROM DC_Html

EXPORTED:
  VAR href
  VAR methods
  VAR name
  VAR rel
  VAR rev
  VAR title
  VAR target
  VAR urn

INLINE METHOD Init( oParent, aGetListItem )

LOCAL aOptions := aGetListItem[xGETLIST_OPTIONS]

::DC_Html:Init( nil, aGetListItem )

DEFAULT aOptions := {}
ASize(aOptions,8)

::target := aOptions[7]
::href := aOptions[2]
::methods := aOptions[3]
::name := aOptions[4]
::rel := aOptions[5]
::rev := aOptions[6]
::urn := aOptions[8]

::title := aGetListItem[cGETLIST_TITLE]

  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel, xParam1, xParam2 )

  LOCAL i, aFont, cHtml := '', cText, cHref, cMethods, cName, ;
        cRel, cRev, cTarget, cUrn, cPre, cPost, lWhen, cTitle

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText,xParam1,xParam2)
  cPost := _GetData(::postHtmlText,xParam1,xParam2)
  cText := _Caption(::htmlText,xParam1,xParam2)
  aFont := _FormatFont(::style,xParam1,xParam2)
  chref := _GetData(::href,xParam1,xParam2)
  cMethods := _GetData(::methods,xParam1,xParam2)
  cName := _GetData(::name,xParam1,xParam2)
  cRel := _GetData(::rel,xParam1,xParam2)
  cRev := _GetData(::rev,xParam1,xParam2)
  cTarget := _GetData(::target,xParam1,xParam2)
  cTitle := _GetData(::title,xParam1,xParam2)
  cUrn := _GetData(::urn,xParam1,xParam2)

  DEFAULT nLevel := 0

  FOR i := 1 TO Len(::childList)
    cText += ::childList[i]:writeHtml(nLevel+1)
  NEXT

  IF Valtype(::whenBlock) == 'B'
    lWhen := Eval(::whenBlock)
  ELSE
    lWhen := .t.
  ENDIF

  IF lWhen
    cHtml += Space(nLevel*3) + cPre + aFont[1] + '<a' + ;
      IIF(!Empty(cHref),' href="' + cHref + '"','') + ;
      IIF(!Empty(cMethods),' methods="' + cMethods + '"','') + ;
      IIF(!Empty(cName),' name="' + cName + '"','') + ;
      IIF(!Empty(cRel),' rel="' + cRel + '"','') + ;
      IIF(!Empty(cRev),' rev="' + cRev + '"','') + ;
      IIF(!Empty(cTarget),' target="' + cTarget + '"','') + ;
      IIF(!Empty(cTitle),' title="' + cTitle + '"','') + ;
      IIF(!Empty(cUrn),' urn="' + cUrn + '"','') + ;
      _OptionNil(::optionArray) + ;
      '>' + cText + '</a>' + aFont[2] + cPost + CRLF
  ELSE
    cHtml += cPre + aFont[1] + cText + aFont[2] + cPost + CRLF
  ENDIF

  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlLink FROM DC_Html

EXPORTED:
  VAR url
  VAR hreflang
  VAR media
  VAR rel
  VAR rev
  VAR charset
  VAR type

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL aOptions

  ::DC_Html:Init( nil, aGetListItem )

  DEFAULT aOptions := {}
  ASize(aOptions,8)

  ::url := aOptions[2]
  ::hreflang := aOptions[3]
  ::media := aOptions[4]
  ::rel := aOptions[5]
  ::rev := aOptions[6]
  ::charset := aOptions[7]
  ::type := aOptions[8]
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel, xParam1, xParam2 )

  LOCAL i, cHtml := '', cText, cUrl, cMedia, cHrefLang, ;
        cCharSet, cRel, cRev, cType, cPre, cPost, lWhen

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText,xParam1,xParam2)
  cPost := _GetData(::postHtmlText,xParam1,xParam2)
  cType := _GetData(::type,xParam1,xParam2)
  cUrl := _GetData(::url,xParam1,xParam2)
  cHrefLang := _GetData(::hreflang,xParam1,xParam2)
  cMedia := _GetData(::media,xParam1,xParam2)
  cCharSet := _GetData(::charset,xParam1,xParam2)
  cRel := _GetData(::rel,xParam1,xParam2)
  cRev := _GetData(::rev,xParam1,xParam2)

  DEFAULT nLevel := 0

  FOR i := 1 TO Len(::childList)
    cText += ::childList[i]:writeHtml(nLevel+1)
  NEXT

  IF Valtype(::whenBlock) == 'B'
    lWhen := Eval(::whenBlock)
  ELSE
    lWhen := .t.
  ENDIF

  IF lWhen
    cHtml += Space(nLevel*3) + cPre + '<link' + ;
      IIF(!Empty(cType),' type="' + cType + '"','') + ;
      IIF(!Empty(cUrl),' href="' + cUrl + '"','') + ;
      IIF(!Empty(cHrefLang),' hreflang="' + cHrefLang + '"','') + ;
      IIF(!Empty(cMedia),' media="' + cMedia + '"','') + ;
      IIF(!Empty(cCharSet),' charset="' + cCharSet + '"','') + ;
      IIF(!Empty(cRel),' rel="' + cRel + '"','') + ;
      IIF(!Empty(cRev),' rev="' + cRev + '"','') + ;
      '>' + cPost + CRLF
  ELSE
    cHtml += cPre + cPost + CRLF
  ENDIF

  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlList FROM DC_Html

EXPORTED:

VAR type
VAR listItems
VAR listType
VAR compact

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL bBlock
  ::DC_Html:Init( nil, aGetListItem )
  ::type := aGetListItem[nGETLIST_SUBTYPE]
  bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])
  IF Valtype(bBlock) == 'B'
    ::listItems := Eval(bBlock)
  ELSE
    ::listItems := {}
  ENDIF
  ::listType := aGetListItem[xGETLIST_OPTIONS2]
  ::compact := aGetListItem[xGETLIST_OPTIONS3]
  DEFAULT ::compact := .f.
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL aFont, i, aType, cHtml := '', cItemType, cType, cPre, cPost

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)
  IF Valtype(::type) == 'N'
    IF ::type == DCHTML_LIST_UNORDERED .OR. Empty(::type)
      cType := 'ul'
    ELSEIF ::type == DCHTML_LIST_ORDERED
      cType := 'ol'
    ELSEIF ::type == DCHTML_LIST_DIRECTORY
      cType := 'dir'
    ELSEIF ::type == DCHTML_LIST_MENU
      cType := 'menu'
    ELSEIF ::type == DCHTML_LIST_DEFINITION
      cType := 'dl'
    ENDIF
  ELSEIF Valtype(::type) == 'C'
    cType := ::type
  ELSE
    cType := 'ul'
  ENDIF

  cItemtype := _ItemType(::listType)

  cHtml += Space(nLevel*3) + ;
           cPre + aFont[1] + '<' + cType +  ;
           IIF(::compact,' compact','') + '>' + CRLF

  FOR i := 1 TO Len(::listItems)
    cHtml += Space((nLevel+1)*3) + '<li' + ;
             IIF(!Empty(cItemType),' type="' + cItemType + '"','') + ;
             '>' + ::listItems[i] + CRLF
  NEXT

  FOR i := 1 TO Len(::childList)
    cHtml += ::childList[i]:writeHtml( nLevel + 1 )
  NEXT

  cHtml += Space(nLevel*3) + '</' + cType + '>' + aFont[2] + cPost + CRLF

  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlListItem FROM DC_Html

EXPORTED:

VAR type
VAR value
VAR caption

INLINE METHOD Init( oParent, aGetListItem )

  ::DC_Html:Init( nil, aGetListItem )
  ::caption := aGetListItem[cGETLIST_CAPTION]
  ::type := aGetListItem[nGETLIST_SUBTYPE]
  ::value := aGetListItem[bGETLIST_REFVAR]
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL aFont, cType, cHtml := '', cValue, cPre, cPost, cMessageInto

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  IF Valtype(::options) == 'O'
    cMessageInto := ::options:messageInto
  ENDIF
  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)
  cValue := Strtran(_GetData(::value),'"','&quot;')
  cType := _ItemType(::type)
  cHtml += Space(nLevel*3) + ;
           cPre + aFont[1] + '<li' + ;
           IIF(!Empty(cType),' type="' +cType +'"','') + ;
           IIF(!Empty(cValue),' value="' + cValue +'"','') + ;
           '>' + ;
           _Caption(::caption,,,::toolTip,::message,cMessageInto) + cPost + CRLF

  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlForm FROM DC_Html

EXPORTED:

VAR encType
VAR action
VAR formMethod
VAR target
VAR name
VAR onReset
VAR onSubmit

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL xOptions
  ::DC_Html:Init( nil, aGetListItem )
  ::encType := aGetListItem[xGETLIST_OPTIONS2]
  ::formMethod := aGetListItem[xGETLIST_OPTIONS3]
  ::target := aGetListItem[xGETLIST_OPTIONS4]
  ::name := aGetListItem[xGETLIST_OPTIONS5]
  ::action := aGetListItem[bGETLIST_ACTION]
  ::_class := aGetListItem[bGETLIST_CLASS]
  xOptions := aGetListItem[xGETLIST_OPTIONS]
  DEFAULT xOptions := {}
  ASize(xOptions,2)
  ::dir := xoptions[1]
  ::lang := xoptions[2]
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL i, cMethod, cAction, cHtml := '', aFont, cPre, cPost

  cAction := ::action

  DEFAULT nLevel := 0, ;
          cAction := '/'

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)
  IF Empty(::formMethod)
    cMethod := 'post'
  ELSEIF Valtype(::formMethod) == 'C'
    cMethod := Alltrim(::formMethod)
  ELSEIF ::formMethod == DCHTML_FORMMETHOD_POST
    cMethod := 'post'
  ELSEIF ::formMethod == DCHTML_FORMMETHOD_GET
    cMethod := 'get'
  ENDIF

  cHtml += Space(nLevel*3) + cPre + aFont[1] + ;
          '<form method=' + cMethod + ;
          IIF(!Empty(::target),' target="' + _GetData(::target) + '"','') + ;
          IIF(!Empty(::name),' name="' + _GetData(::name) + '"','') + ;
          IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
          IIF(!Empty(::dir),' dir="' + _GetData(::dir) + '"','') + ;
          IIF(!Empty(::lang),' lang="' + _GetData(::lang) + '"','') + ;
          ' action="' + cAction + '">' + CRLF

  FOR i := 1 TO Len(::childList)
    cHtml += ::childList[i]:WriteHtml( nLevel + 1 )
  NEXT

  cHtml += Space(nLevel*3) + ;
          '</form>' + aFont[2] + cPost + CRLF
  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlTag FROM DC_Html

EXPORTED:

VAR tagName

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL xOptions
  ::DC_Html:Init( nil, aGetListItem )
  ::_class := aGetListItem[bGETLIST_CLASS]
  ::tagName := aGetListItem[cGETLIST_CAPTION]
  xOptions := aGetListItem[xGETLIST_OPTIONS]
  DEFAULT xOptions := {}
  ASize(xOptions,2)
  ::dir := xoptions[1]
  ::lang := xoptions[2]
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL i, cMethod, cAction, cHtml := '', aFont, cPre, cPost

  DEFAULT nLevel := 0

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)

  cHtml += Space(nLevel*3) + cPre + aFont[1] + ;
          '<' + ::tagName + ;
          IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
          IIF(!Empty(::dir),' dir="' + _GetData(::dir) + '"','') + ;
          IIF(!Empty(::lang),' lang="' + _GetData(::lang) + '"','') + ;
          '>' + CRLF

  FOR i := 1 TO Len(::childList)
    cHtml += ::childList[i]:WriteHtml( nLevel + 1 )
  NEXT

  cHtml += Space(nLevel*3) + ;
          '</' + ::tagName + '>' + aFont[2] + cPost + CRLF
  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlInput FROM DC_Html

EXPORTED:

VAR type
VAR checked
VAR maxLength
VAR size
VAR value
VAR src
VAR caption
VAR listArray
VAR tabIndex
VAR accessKey
VAR accept

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL xOptions
  ::DC_Html:Init( nil, aGetListItem )

  ::type := aGetListItem[nGETLIST_SUBTYPE]
  ::size := aGetListItem[xGETLIST_OPTIONS2]
  ::src := aGetListItem[xGETLIST_OPTIONS3]
  ::checked := aGetListItem[xGETLIST_OPTIONS4]
  ::maxLength := aGetListItem[xGETLIST_OPTIONS5]
  ::value := aGetListItem[xGETLIST_OPTIONS6]
  ::caption := aGetListItem[cGETLIST_CAPTION]
  ::listArray := aGetListItem[bGETLIST_REFVAR]

  xOptions := aGetListItem[xGETLIST_OPTIONS]
  DEFAULT xOptions := {}
  ASize(xOptions, 3)

  ::accessKey := xOptions[1]
  ::tabIndex := xOptions[2]
  ::accept := xOptions[3]
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF

  RETURN self

INLINE METHOD WriteHtml( nLevel, nMode )

  LOCAL cValue, cType, aFont, cHtml := '', cHeight, cWidth, aOptions, ;
        cOptions, i, cPre, cPost, cMessageInto

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)
  DEFAULT nMode := 2

  cValue := Strtran(_GetData(::value),'"','&quot;')
  IF Valtype(::type) == 'N'
    IF ::type == DCHTML_INPUT_TEXT
      cType := 'text'
    ELSEIF ::type == DCHTML_INPUT_PASSWORD
      cType  := 'password'
    ELSEIF ::type == DCHTML_INPUT_CHECKBOX
      cType  := 'checkbox'
    ELSEIF ::type == DCHTML_INPUT_RADIOBUTTON
      cType := 'radio'
    ELSEIF ::type == DCHTML_INPUT_SUBMITBUTTON
      cType := 'submit'
    ELSEIF ::type == DCHTML_INPUT_RESETBUTTON
      cType := 'reset'
    ELSEIF ::type == DCHTML_INPUT_IMAGE
      cType := 'image'
    ELSEIF ::type == DCHTML_INPUT_HIDDEN
      cType := 'hidden'
    ELSEIF ::type == DCHTML_INPUT_TEXTAREA
      cType := 'textarea'
    ELSEIF ::type == DCHTML_INPUT_SELECT
      cType := 'select'
    ELSEIF ::type == DCHTML_INPUT_BUTTON
      cType := 'button'
    ELSEIF ::type == DCHTML_INPUT_FILE
      cType := 'file'
    ELSE
      cType := 'text'
    ENDIF
  ELSEIF Valtype(::type) == 'C'
    cType := ::type
  ELSE
    cType := 'text'
  ENDIF

  IF Valtype(::options) == 'O'
    cMessageInto := ::options:messageInto
  ENDIF
  cWidth := Alltrim(DC_XtoC(_GetData(::width)))
  cHeight := Alltrim(DC_XtoC(_GetData(::height)))
  IF nMode = 1 // print caption or header
    cHtml += aFont[1] + _Caption(::caption,,,::toolTip,::message,cMessageInto) + aFont[2]
  ELSEIF nMode = 2
    IF cType = 'textarea'
      cHtml := Space(nLevel*3) + cPre + aFont[1] + ;
         '<textarea' + ;
         IIF(!Empty(::varName),' name="' + ::varName + '"','') + ;
         ' rows=' + cHeight + ;
         ' cols=' + cWidth + ;
         IIF(!Empty(::tabIndex),' tabindex=' + _GetData(::tabIndex),'') + ;
         IIF(!Empty(::accept),' accept="' + _GetData(::tabIndex) + '"','') + ;
         IIF(!Empty(::accessKey),' accesskey="' + _GetData(::accessKey) + '"','') + ;
         IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
         '>' + cValue  + ;
         Space(nLevel*3) + '</textarea>' + ;
         aFont[2] + cPost + CRLF
    ELSEIF cType = 'select'
      IF Val(cHeight) <= 0
        cHeight := '1'
      ENDIF
      aOptions := _GetData(::listArray)
      DEFAULT aOptions := {}
      cOptions := ''
      FOR i := 1 TO Len(aOptions)
        cOptions += Space(nLevel*3) + ;
                '<option' + IIF(Trim(cValue)==aOptions[i],' selected','') + ;
                '>' + DC_XtoC(aOptions[i]) + '</option>' + CRLF
      NEXT
      RETURN Space(nLevel*3) + cPre + aFont[1] + '<select name="' + ::varName + '"' + ;
         IIF(!Empty(::tabIndex),' tabindex=' + _GetData(::tabIndex),'') + ;
         IIF(!Empty(::accept),' accept="' + _GetData(::tabIndex) + '"','') + ;
         IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
         ' size="' + cHeight + '">' + CRLF + ;
         cOptions + ;
         Space(nLevel*3) + '</select>' + ;
         aFont[2] + cPost + CRLF
    ELSE

      cHtml += Space(nLevel*3) + cPre + aFont[1] + '<input' + ;
         ' type=' + cType + ;
         IIF(!Empty(cValue),' value="' + cValue + '"','')  + ;
         IIF(!Empty(::varName),' name="' + ::varName + '"','') + ;
         IIF(!Empty(::size),' size=' + Alltrim(Str(::size)),'') + ;
         IIF(!Empty(::tabIndex),' tabindex=' + _GetData(::tabIndex),'') + ;
         IIF(!Empty(::accept),' accept="' + _GetData(::tabIndex) + '"','') + ;
         IIF(!Empty(::accessKey),' accesskey="' + _GetData(::accessKey) + '"','') + ;
         IIF(!Empty(::maxLength),' maxlength=' + Alltrim(Str(::maxLength)),'') + ;
         IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
         IIF(!Empty(::checked),' checked','') + ;
         IIF(!Empty(::checked),' selected','') + ;
         IIF(!Empty(::src),' src="' + ::src + '"','') + ;
         '>' + aFont[2] + cPost + CRLF
    ENDIF
  ENDIF
  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlGet FROM DC_Html

EXPORTED:

VAR passWord

INLINE METHOD Init( oParent, aGetListItem )

  ::DC_Html:Init( nil, aGetListItem )
  ::passWord := aGetListItem[xGETLIST_OPTIONS5]
  DEFAULT ::passWord := .f.
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF

  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL cData, aFont, cName := ::varName, cPre, cPost, nWidth, nMaxLength

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)
  cData := DC_XtoC(Eval(::dataLink))
  nMaxLength := Len(cData)
  cData := Strtran(cData,'"','&quot;')
  IF !Empty(::width)
    nWidth := ::width
  ELSE
    nWidth := Len(cData)
  ENDIF

  RETURN Space(nLevel*3) + cPre + aFont[1] + '<input name="' + ::varName + '"' + ;
         ' type=' + IIF(::passWord,'password','text') + ;
         IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
         ' value="' + Trim(cData)  + '"' + ;
         ' maxlength=' + Alltrim(Str(nMaxLength)) + ;
         ' size=' + Alltrim(Str(nWidth)) + ;
         '>' + aFont[2] + cPost + CRLF

ENDCLASS

* -----------

CLASS DC_HtmlMle FROM DC_Html

EXPORTED:

INLINE METHOD Init( oParent, aGetListItem )
  ::DC_Html:Init( nil, aGetListItem )
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL cData, aFont, cWidth, cHeight, cPre, cPost

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF
  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)
  cWidth := Alltrim(DC_XtoC(_GetData(::width)))
  cHeight := Alltrim(DC_XtoC(_GetData(::height)))
  cData := Strtran(DC_XtoC(Eval(::dataLink)),'"','&quot;')
  RETURN Space(nLevel*3) + cPre + aFont[1] + '<textarea name="' + ::varName + ;
         IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
         '" rows=' + cHeight + ;
         ' cols=' + cWidth + ;
         '>' + cData  + ;
         '</textarea>' + ;
         aFont[2] + cPost + CRLF

ENDCLASS

* -----------

CLASS DC_HtmlCheckBox FROM DC_Html

EXPORTED:
INLINE METHOD Init( oParent, aGetListItem )
  ::DC_Html:Init( nil, aGetListItem )
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self
INLINE METHOD WriteHtml( nLevel )
  LOCAL cPre, cPost, cMessageInto, aFont
  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF
  IF Valtype(::options) == 'O'
    cMessageInto := ::options:messageInto
  ENDIF
  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)
  RETURN Space(nLevel*3) + cPre + aFont[1] + ;
         _Caption(::htmlText,,,::toolTip,::message,cMessageInto) + '<input name="' + ::varName + ;
         '" type=checkbox ' + ;
         IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
         IIF(Eval(::dataLink), ' CHECKED','')  + '>' + aFont[2] + cPost + CRLF
ENDCLASS

* ------------

CLASS DC_HtmlRadioButton FROM DC_Html

EXPORTED:

VAR dataValue

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL xOptions
  ::DC_Html:Init( nil, aGetListItem )
  xOptions := aGetListItem[xGETLIST_OPTIONS]
  DEFAULT xOptions := {}
  ASize(xOptions,2)
  ::dataValue := DC_Xtoc(xOptions[1])
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL cCaption, aFont, xValue, cPre, cPost, cMessageInto

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  IF Valtype(::options) == 'O'
    cMessageInto := ::options:messageInto
  ENDIF
  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)
  cCaption := _Caption(::htmlText,,,::toolTip,::message,cMessageInto)
  xValue := DC_XtoC(Eval(::dataLink))
  RETURN Space(nLevel*3) + cPre + aFont[1] + '<input name="' + ::varName + ;
         '" type=radio' + ;
         IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
         ' value="' + ::dataValue + '"' + ;
         IIF(xValue==::dataValue, ' CHECKED','')  + '>' + ;
         cCaption + aFont[2] + cPost + CRLF

ENDCLASS

* ------------

CLASS DC_HtmlComboBox FROM DC_Html

EXPORTED:

VAR listArray

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL bBlock
  ::DC_Html:Init( nil, aGetListItem )
  ::listArray := aGetListItem[bGETLIST_REFVAR]
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL xValue, i, cOptions := '', aFont, cHeight, aOptions, cPre, cPost

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  aOptions := _GetData(::listArray)
  DEFAULT aOptions := {}
  cHeight := Alltrim(_GetData(::height))
  IF Val(cHeight) <= 0
    cHeight := '1'
  ENDIF
  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  xValue := Eval(::dataLink)
  aFont := _FormatFont(::style)

  FOR i := 1 TO Len(aOptions)
    cOptions += Space(nLevel*3) + ;
                '<option' + IIF(Trim(DC_XtoC(xValue))==DC_Xtoc(aOptions[i]),' selected','') + ;
                '>' + DC_XtoC(aOptions[i]) + '</option>' + CRLF
  NEXT
  RETURN Space(nLevel*3) + cPre + aFont[1] + '<select name="' + ::varName + '"' + ;
         ' size="' + cHeight + '">' + CRLF + ;
         cOptions + ;
         Space(nLevel*3) + '</select>' + ;
         aFont[2] + cPost + CRLF

ENDCLASS

* -----------

CLASS DC_HtmlSubmit FROM DC_Html

EXPORTED:
VAR type
VAR imageSrc

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL xOptions
  ::DC_Html:Init( nil, aGetListItem )
  ::type := aGetListItem[nGETLIST_SUBTYPE]
  ::imageSrc := aGetListItem[xGETLIST_OPTIONS2]
  ::_class := aGetListItem[bGETLIST_CLASS]
  xOptions := aGetListItem[xGETLIST_OPTIONS]
  DEFAULT xOptions := {}
  ASize(xOptions,2)
  ::dir := xoptions[1]
  ::lang := xoptions[2]

  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel, nMode )

  LOCAL cType, cCaption, aFont, cSrc, lWhen := .t., cHtml, cPre, ;
        cPost, cMessageInto

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  DEFAULT nMode := 1
  IF Valtype(::options) == 'O'
    cMessageInto := ::options:messageInto
  ENDIF
  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)
  cCaption := _Caption(::htmlText,,,::toolTip,::message,cMessageInto,nMode)

  cSrc := _GetData(::imageSrc)

  IF Valtype(::whenBlock) == 'B' .AND. Valtype(cSrc) == 'A'
    lWhen := Eval(::whenBlock)
    IF lWhen
      cSrc := cSrc[1]
    ELSE
      cSrc := cSrc[2]
    ENDIF
  ELSEIF Valtype(cSrc) == 'A'
    cSrc := cSrc[1]
  ENDIF

  IF ::type == DCHTML_BUTTONTYPE_SUBMIT
    cType := 'submit'
  ELSEIF ::type == DCHTML_BUTTONTYPE_RESET
    cType := 'reset'
  ELSEIF ::type == DCHTML_BUTTONTYPE_IMAGE
    cType := 'image'
  ENDIF
  DEFAULT cType := 'submit'

  IF lWhen
    cHtml := Space(nLevel*3) + cPre + aFont[1] + '<input' + ;
         IIF(!Empty(::varName),' name="' + ::varName + '"','') + ;
         ' type=' + cType + ;
         ' value="' + cCaption + '"' + ;
         _OptionNil(::_class,'class') + ;
         _OptionNil(::dir,'dir') + ;
         _OptionNil(::lang,'lang') + ;
         _OptionNil(::optionArray) + ;
         iif(::type==DCHTML_BUTTONTYPE_IMAGE,' src="' + cSrc + '"','') + ;
         '>' + ;
         aFont[2] + cPost + CRLF
  ELSE
    cHtml := Space(nLevel*3) + cPre + aFont[1] + '<img' + ;
         iif(::type==DCHTML_BUTTONTYPE_IMAGE,' src="' + cSrc + '"','') + ;
         '>' + ;
         aFont[2] + cPost + CRLF
  ENDIF

  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlFrameSet FROM DC_Html

EXPORTED:

VAR columns
VAR rows
VAR frameBorder
VAR onLoad
VAR onUnload

INLINE METHOD Init( oParent, aGetListItem )

LOCAL aOptions

  ::DC_Html:Init( nil, aGetListItem, self )
  ::columns := aGetListItem[nGETLIST_WIDTH]
  ::rows := aGetListItem[nGETLIST_HEIGHT]
  ::border := aGetListItem[nGETLIST_SUBTYPE]
  ::frameBorder := aGetListItem[xGETLIST_OPTIONS2]
  aOptions := aGetListItem[xGETLIST_OPTIONS]
  DEFAULT aOptions := {}
  ASize(aOptions,1)
  ::onLoad := aOptions[1]
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF

  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL i, cHtml := '', cCaption, cPre, cPost, cMessageInto, cBorderColor

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  IF Valtype(::options) == 'O'
    cMessageInto := ::options:messageInto
  ENDIF
  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  cCaption := _Caption(::htmlText,,,::toolTip,::message,cMessageInto)
  cBorderColor := DC_XbpToHtmlColor(::fgColor)

  DEFAULT nLevel := 0

  cHtml += cPre + '<frameset' + ;
           IIF(!Empty(::columns),' cols="' + ::columns + '"','') + ;
           IIF(!Empty(::rows),' rows="' + ::rows + '"','') + ;
           IIF(!Empty(::border),' border=' + _GetData(::border),'') + ;
           IIF(!Empty(::onload),' onload="' + _GetData(::onload) + '"','') + ;
           IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
           IIF(!Empty(::frameBorder),' frameborder=' + _GetData(::frameBorder),'') + ;
           IIF(!Empty(cBorderColor),' bordercolor="' + ::bordercolor + '"','') + ;
           '>' + cPost + CRLF

  FOR i := 1 TO Len(::childList)
    cHtml += ::childList[i]:WriteHtml( nLevel + 1 )
  NEXT

  cHtml += '</frameset>' + CRLF

  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlFrame FROM DC_Html

EXPORTED:

VAR sourceUrl
VAR frameName
VAR marginHeight
VAR marginWidth
VAR noResize
VAR scrolling
VAR frameBorder

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL xOptions, lNoScroll
  ::DC_Html:Init( nil, aGetListItem )
  ::frameName := aGetListItem[cGETLIST_CAPTION]
  ::marginHeight := aGetListItem[xGETLIST_OPTIONS2]
  ::marginWidth := aGetListItem[xGETLIST_OPTIONS3]
  ::noResize := aGetListItem[xGETLIST_OPTIONS4]
  lNoScroll := aGetListItem[xGETLIST_OPTIONS5]
  IF Valtype(lNoScroll) = 'L'
    ::scrolling := !lNoScroll
  ENDIF
  xOptions := aGetListItem[xGETLIST_OPTIONS]

  DEFAULT ::noResize := .f., ;
          ::scrolling := .t., ;
          ::frameName := 'testframe', ;
          xOptions := {}

  ASize(xOptions,3)
  ::border := xOptions[1]
  ::frameBorder := xOptions[2]
  ::sourceUrl := xOptions[3]

  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF

  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL i, cHtml := '', cFrameHtml := '', cCaption, cSourceUrl, cPre, cPost, ;
        cBorder, cFrameBorder, cMessageInto, cBorderColor

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  IF Valtype(::options) == 'O'
    cMessageInto := ::options:messageInto
  ENDIF

  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  cCaption := _Caption(::htmlText,,,::toolTip,::message,cMessageInto)
  cSourceUrl := _GetData(::sourceUrl)
  cBorderColor := DC_XbpToHtmlColor(::fgColor)

  FOR i := 1 TO Len(::childList)
    cFrameHtml += ::childList[i]:WriteHtml( nLevel + 1 )
  NEXT

  IF Empty(cSourceUrl)
    cSourceUrl := _TempFileName()
    MemoWrit( ::options:rootdir + cSourceUrl, cFrameHtml )
  ENDIF

  cHtml += Space(nLevel*3) + ;
           cPre + '<frame' + ;
           IIF(!Empty(::frameName),' name="' + ::frameName + '"','') + ;
           IIF(!::marginHeight==NIL,' marginheight=' + Alltrim(_GetData(::marginHeight)),'') + ;
           IIF(!::marginWidth==NIL,' marginwidth=' + Alltrim(_GetData(::marginWidth)),'') + ;
           IIF(!::border==NIL,' border=' + Alltrim(_GetData(::border)),'') + ;
           IIF(!::frameBorder==NIL,' frameborder=' + Alltrim(_GetData(::frameBorder)),'') + ;
           IIF(!Empty(cBorderColor),' bordercolor="' + ::bordercolor + '"','') + ;
           IIF(!Empty(::_class),' class="' + _GetData(::_class) + '"','') + ;
           IIF(::noResize,' noresize','') + ;
           IIF(::scrolling,' scrolling="Yes"',' scrolling="No"') + ;
           IIF(!Empty(cSourceUrl),' src="' + cSourceUrl + '"','') + ;
           '>' + cPost + CRLF

  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlBrowse FROM DC_HtmlTable

EXPORTED:

VAR dataSource
VAR pointer
VAR arrayElement
VAR headerDelim
VAR footerDelim

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL bBlock, xData

  ::DC_HtmlTable:Init( nil, aGetListItem )
  ::headerDelim := ';'
  ::footerDelim := ';'
  ::tableRows := aGetListItem[nGETLIST_HEIGHT]
  ::tableColumns := aGetListItem[nGETLIST_WIDTH]
  DEFAULT ::tableRows := 0, ;
          ::tableColumns := 0

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])
  IF Valtype(bBlock) = 'B'
    xData := Eval( bBlock )
  ELSEIF Valtype(aGetListItem[cGETLIST_VARNAME]) = 'C'
    xData := aGetListItem[cGETLIST_VARNAME]
  ENDIF

  IF Valtype(xData) # 'A' .AND. Empty(xData)
    xData := Alias()
    IF Empty(xData)
      DC_WinAlert('DC_HtmlBrowse() error! Browse has no data source')
      RETURN self
    ENDIF
  ENDIF

  IF Valtype(xData) = 'A'
    aGetListItem[nGETLIST_SUBTYPE] = BROWSE_ARRAY
  ELSEIF Valtype(xData) = 'C'
    aGetListItem[nGETLIST_SUBTYPE] = BROWSE_DATABASE
  ENDIF
  ::dataSource := xData
  IF Valtype(::dataSource) == 'C'
    ::pointer := (::dataSource)->(RecNo())
  ELSE
    ::pointer := 1
    ::arrayElement := 1
  ENDIF

  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel )

  LOCAL i, j, cHtml := '', aFont, cBorder, cPre, cPost, cBgColor, ;
        nSaveRecord, cClass, cWidth, lHeaders := .F., lFooters := .F.

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  DEFAULT nLevel := 0
  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  aFont := _FormatFont(::style)
  cBorder := _GetData(::tableBorder)
  cClass := _GetData(::tableClass)
  cWidth := _GetData(::tableWidth)
  cBgColor := DC_XbpToHtmlColor(::bgColor)
  cHtml += aFont[1]

  cHtml += Space(nLevel*3) + ;
    cPre + '<table' + ;
    _OptionEmpty(cWidth,'width') + ;
    _OptionNil(cClass,'class') + ;
    _OptionEmpty(cBorder,'border') + ;
    _OptionNil(cBgColor,'bgcolor') + ;
    '>' + CRLF

  // write headers
  FOR j := 1 TO Len(::childList)
    IF ::childList[j]:isDerivedFrom('DC_HtmlColumn') .AND. !Empty(::childList[j]:headerArray)
      lHeaders := .T.
      EXIT
    ENDIF
  NEXT

  IF lHeaders
    cHtml += ' <tr' + ;
      _OptionNil(::tableTRClass,'class') + ;
      _OptionNil(::tableTRStyle,'style') + ;
     '>' + CRLF

    FOR j := 1 TO Len(::childList)
      IF ::childList[j]:isDerivedFrom('DC_HtmlColumn')
        cHtml += ::childList[j]:writeHtml(nLevel+1,1,j)
      ELSE
        cHtml += '<th></th>' + CRLF
      ENDIF
    NEXT
    cHtml += '</tr>' + CRLF
  ENDIF

  IF Valtype(::dataSource) == 'C'
    nSaveRecord := (::dataSource)->(RecNo())
  ENDIF

  // write data
  FOR i := 1 TO ::tableRows
    cHtml += ' <tr' + ;
     _OptionNil(::tableTRClass,'class') + ;
      '>' + CRLF
    FOR j := 1 TO Len(::childList)
      IF ::childList[j]:isDerivedFrom('DC_HtmlColumn')
        cHtml += ::childList[j]:writeHtml(nLevel+1,2,::arrayElement)
      ELSE
        cHtml += '<td>' + ::childList[j]:writeHtml(nLevel+1,2,::arrayElement) + '</td>' + CRLF
      ENDIF
    NEXT
    IF Valtype(::dataSource) == 'C'
      (::dataSource)->(DC_DbSkip())
      IF (::dataSource)->(DC_Eof())
        EXIT
      ENDIF
      ::pointer := (::dataSource)->(RecNo())
    ELSE
      ::pointer ++
      ::arrayElement ++
    ENDIF
    cHtml += '</tr>' + CRLF
  NEXT
  IF !Empty(nSaveRecord)
    (::dataSource)->(dbGoto(nSaveRecord))
    ::pointer := nSaveRecord
  ENDIF

  // write footers
  FOR j := 1 TO Len(::childList)
    IF ::childList[j]:isDerivedFrom('DC_HtmlColumn') .AND. !Empty(::childList[j]:footerArray)
      lFooters := .T.
      EXIT
    ENDIF
  NEXT

  IF lFooters
    cHtml += ' <tr' + ;
      _OptionNil(::tableTRClass,'class') + ;
      '>' + CRLF
    FOR j := 1 TO Len(::childList)
      IF ::childList[j]:isDerivedFrom('DC_HtmlColumn')
        cHtml += ::childList[j]:writeHtml(nLevel+1,3,j)
      ELSE
        cHtml += '<th></th>' + CRLF
      ENDIF
    NEXT
    cHtml += '</tr>' + CRLF
  ENDIF

  cHtml += '</table>' + aFont[2] + cPost + CRLF

  RETURN cHtml

ENDCLASS

* -----------

CLASS DC_HtmlColumn FROM DC_Html

EXPORTED:

VAR element
VAR headerArray
VAR headerBlock
VAR headerColor
VAR headerFont
VAR headerClass
VAR headerWidth
VAR footerArray
VAR footerBlock
VAR footerColor
VAR footerFont
VAR footerClass
VAR dataClass

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL cCaption, aHeader, aFooter, xOptions

  ::DC_Html:Init( nil, aGetListItem )

  xOptions := aGetListItem[xGETLIST_OPTIONS]

  DEFAULT xOptions := {}
  ASize(xOptions,8)

  // get pointer to array element
  ::element := aGetListItem[nGETLIST_POINTER]
  IF Valtype( ::element ) = 'N' // it's an array we're browsing
    ::dataLink := DC_GetColBlock( ::element, oParent )
    aGetListItem[bGETLIST_VAR] := ::dataLink
  ELSE // it's a database wer'e browsing
    ::dataLink := DC_GetBlock( aGetListItem[bGETLIST_VAR] )
    IF Valtype(::dataLink) # 'B'
      ::dataLink := DC_GetBlock( aGetListItem[bGETLIST_REFVAR] )
    ENDIF
  ENDIF

  cCaption := aGetListItem[cGETLIST_CAPTION]
  IF Valtype(cCaption) = 'B'
    ::headerBlock := cCaption
    cCaption := Eval(::headerBlock)
  ENDIF
  IF Valtype(cCaption) = 'C'
    aHeader := DC_TokenArray( cCaption, oParent:headerDelim )
    ::headerArray := aHeader
  ELSEIF Valtype(cCaption) = 'A'
    ::headerArray := aHeader
  ENDIF

  cCaption := xOptions[3]
  IF Valtype(cCaption) = 'B'
    ::footerBlock := cCaption
    cCaption := Eval(::footerBlock)
  ENDIF
  IF Valtype(cCaption) = 'C'
    aFooter := DC_TokenArray( cCaption, oParent:footerDelim )
    ::footerArray := aFooter
  ELSEIF Valtype(cCaption) = 'A'
    ::footerArray := aFooter
  ENDIF

  ::headerColor := DC_XbpToHtmlColor(aGetListItem[xGETLIST_OPTIONS2])
  ::footerColor := DC_XbpToHtmlColor(aGetListItem[xGETLIST_OPTIONS8])

  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
    ::parent := oParent
  ENDIF
  RETURN self

INLINE METHOD WriteHtml( nLevel, nMode )

  LOCAL i, cHtml := '', cColor, aFont, cPre, cPost, aHeaderFont, ;
        aFooterFont, cWidth, cClass, cHeaderClass, cFooterClass, ;
        cDataClass, cHeaderWidth

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  DEFAULT nLevel := 0
  DEFAULT nMode := 2  // data area
  cPre := _GetData(::preHtmlText)
  cPost := _GetData(::postHtmlText)
  cWidth := _GetData(::width)
  cClass := _GetData(::_class)
  cHeaderClass := _GetData(::headerClass)
  cHeaderWidth := _GetData(::headerWidth)
  cFooterClass := _GetData(::footerClass)
  cDataClass := _GetData(::dataClass)
  aFont := _FormatFont(::style)
  aHeaderFont := _FormatFont(::headerFont)
  aFooterFont := _FormatFont(::footerFont)
  IF Empty(aFont[1])
    aFont := _FormatFont(::parent:font)
  ENDIF
  IF Empty(aHeaderFont[1])
    aHeaderFont := _FormatFont(::parent:font)
  ENDIF
  IF Empty(aFooterFont[1])
    aFooterFont := _FormatFont(::parent:font)
  ENDIF
  IF nMode ==1 .AND. !Empty(::headerArray) // header
    IF Valtype(::headerColor) == 'B'
      cColor := DC_XbpToHtmlColor(::headerColor)
    ELSE
      cColor := ::headerColor
    ENDIF
    IF Valtype(cColor) == 'A'
      cColor := cColor[2]
    ENDIF
    cHtml += '<th' + ;
    _OptionEmpty(cColor,'bgcolor') + ;
    _OptionEmpty(cHeaderWidth,'width') + ;
    _OptionEmpty(cClass,'class') + ;
    _OptionEmpty(cHeaderClass,'class') + ;
    '>'
    FOR i := 1 TO Len(::headerArray)
      cHtml += aHeaderFont[1] + ::headerArray[i] + IIF(i<Len(::headerArray),'<br>','')
    NEXT
    cHtml += aHeaderFont[2] + '</th>' + CRLF
  ELSEIF nMode == 2 // data area
    IF Valtype(::bgColor) == 'B'
      cColor := DC_XbpToHtmlColor(::bgColor,Eval(::dataLink))
    ELSE
      cColor := ::bgColor
    ENDIF
    IF Valtype(cColor) == 'A'
      cColor := cColor[2]
    ENDIF
    cHtml += cPre + '<td' + ;
    _OptionEmpty(cColor,'bgcolor') + ;
    _OptionEmpty(cWidth,'width') + ;
    _OptionEmpty(cClass,'class') + ;
    _OptionEmpty(cDataClass,'class') + ;
    '>'
    cHtml += aFont[1]
    cHtml += Trim(DC_XtoC(Eval(::dataLink)))
    cHtml += aFont[2]
    cHtml += '</td>' + cPost + CRLF
  ELSEIF nMode == 3 .AND. !Empty(::footerArray) // footer
    IF Valtype(::footerColor) == 'B'
      cColor := DC_XbpToHtmlColor(::footerColor)
    ELSE
      cColor := ::footerColor
    ENDIF
    IF Valtype(cColor) == 'A'
      cColor := cColor[2]
    ENDIF
    cHtml += aFooterFont[1] + '<th' + ;
    _OptionEmpty(cColor,'bgcolor') + ;
    _OptionEmpty(cWidth,'width') + ;
    _OptionEmpty(cClass,'class') + ;
    _OptionEmpty(cFooterClass,'class') + ;
    '>'
    FOR i := 1 TO Len(::footerArray)
      cHtml += ::footerArray[i] + IIF(i<Len(::footerArray),'<br>','')
    NEXT
    cHtml += aFooterFont[2] + '</th>' + CRLF
  ENDIF
  RETURN cHtml

ENDCLASS

* ------------

CLASS DC_HtmlDiv FROM DC_Html

EXPORTED:

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL cCaption, aHeader, aFooter, xOptions

  ::DC_Html:Init( nil, aGetListItem )

  RETURN self

INLINE METHOD WriteHtml( nLevel, nMode )


  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  RETURN ''

ENDCLASS

* ------------

CLASS DC_HtmlMenuBar FROM DC_Html

EXPORTED:

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL cCaption, aHeader, aFooter, xOptions

  ::DC_Html:Init( nil, aGetListItem )

  RETURN self

INLINE METHOD WriteHtml( nLevel, nMode )

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  RETURN ''

ENDCLASS

* ------------

CLASS DC_HtmlSubMenu FROM DC_Html

EXPORTED:

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL cCaption, aHeader, aFooter, xOptions

  ::DC_Html:Init( nil, aGetListItem )

  RETURN self

INLINE METHOD WriteHtml( nLevel, nMode )

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  RETURN ''

ENDCLASS

* ------------

CLASS DC_HtmlMenuItem FROM DC_Html

EXPORTED:

INLINE METHOD Init( oParent, aGetListItem )

  LOCAL cCaption, aHeader, aFooter, xOptions

  ::DC_Html:Init( nil, aGetListItem )

  RETURN self

INLINE METHOD WriteHtml( nLevel, nMode )

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  RETURN ''

ENDCLASS

* ------------

FUNCTION DC_XbpToHtmlColor( aColor, xData )

LOCAL i, j, aOutColor[2], nColor, cColor

IF Valtype(aColor) == 'B'
  aColor := Eval(aColor, xData)
ENDIF
IF aColor == nil
  aOutColor := nil
ELSEIF aColor == nil
  aOutColor := nil
ELSEIF Valtype(aColor) == 'C'
  aOutColor := aColor
ELSEIF Valtype(aColor) == 'N'
  aOutColor := _NumColorToHtmlColor(aColor)
ELSEIF Valtype(aColor) == 'A' .AND. Len(aColor) == 3
  aOutColor := '#'
  FOR i := 1 TO 3
    aOutColor += DC_Dec2Hex(aColor[i])
  NEXT
ELSEIF Valtype(aColor) == 'A'
  aFill(aOutColor,'')
  ASize(aColor,2)
  FOR i := 1 TO 2
    IF Valtype(aColor[i]) == 'A'
      aOutColor[i] := '#'
      FOR j := 1 TO 3
        aOutColor[i] += DC_Dec2Hex(aColor[i,j])
      NEXT
    ELSEIF Valtype(aColor[i]) == 'N'
      aOutColor[i] := _NumColorToHtmlColor(aColor[i])
    ELSEIF Valtype(aColor[i]) == 'C' .AND. aColor[i,1] == '#'
      aOutColor[i] := aColor[i]
    ENDIF
  NEXT
ELSEIF Valtype(aColor) == 'B'
  aOutColor := aColor
ENDIF

RETURN aOutColor

* ------------

FUNCTION DC_HtmlToXbpColor( cHtmlColor )

LOCAL aColor[3], cColor, nColor, i

cHtmlColor := Strtran(cHtmlColor,'#','')
FOR i := 0 TO 2
  cColor := Substr(cHtmlColor,(i*2)+1,2)
  nColor := DC_Hex2Dec(cColor)
  aColor[i+1] := nColor
NEXT

RETURN aColor

* ------------

STATIC FUNCTION _NumColorToHtmlColor( nColor )

LOCAL cColor := '#FFFFFF'

IF nColor == GRA_CLR_BLACK
  cColor := '#000000'
ELSEIF nColor == GRA_CLR_BLUE
  cColor := '#0000FF'
ELSEIF nColor == GRA_CLR_DARKBLUE
  cColor := '#000077'
ELSEIF nColor == GRA_CLR_GREEN
  cColor := '#00FF00'
ELSEIF nColor == GRA_CLR_DARKGREEN
  cColor := '#007700'
ELSEIF nColor == GRA_CLR_RED
  cColor := '#FF0000'
ELSEIF nColor == GRA_CLR_DARKRED
  cColor := '#770000'
ELSEIF nColor == GRA_CLR_WHITE
  cColor := '#FFFFFF'
ELSEIF nColor == GRA_CLR_PALEGRAY
  cColor := '#CCCCCC'
ELSEIF nColor == GRA_CLR_DARKGRAY
  cColor := '#777777'
ELSEIF nColor == GRA_CLR_CYAN
  cColor := '#00FFFF'
ELSEIF nColor == GRA_CLR_DARKCYAN
  cColor := '#007777'
ELSEIF nColor == GRA_CLR_PINK
  cColor := '#FF00FF'
ELSEIF nColor == GRA_CLR_DARKPINK
  cColor := '#770077'
ELSEIF nColor == GRA_CLR_BROWN
  cColor := '#777700'
ELSEIF nColor == GRA_CLR_YELLOW
  cColor := '#FFFF00'
ELSEIF nColor == GRA_CLR_NEUTRAL
ENDIF

RETURN cColor

* ------------

FUNCTION DC_XbpToHtmlFont( cFont )
RETURN cFont

* ------------

FUNCTION DC_HtmlOptDefault( aHtmlOptions )

STATIC aHtmlOptDefault := {}
LOCAL i
LOCAL aHtmlOptValid := ;
     { 'Untitled',                            /* cHTMLOPT_NAME          */     ;
       'Untitled',                            /* cHTMLOPT_TITLE         */     ;
       0,                                     /* nHTMLOPT_HEIGHT        */     ;
       0,                                     /* nHTMLOPT_WIDTH         */     ;
       '10.Arial',                            /* cHTMLOPT_SAYFONT       */     ;
       '10.Courier',                          /* cHTMLOPT_GETFONT       */     ;
       0,                                     /* nHTMLOPT_STARTROW      */     ;
       0,                                     /* nHTMLOPT_STARTCOL      */     ;
       .f.,                                   /* lHTMLOPT_SAYRIGHT      */     ;
       '',                                    /* cHTMLOPT_WALLPAPER     */     ;
       20,                                    /* nHTMLOPT_ROWS          */     ;
       40,                                    /* nHTMLOPT_COLS          */     ;
       20,                                    /* nHTMLOPT_ROWPIXELS     */     ;
       7,                                     /* nHTMLOPT_COLPIXELS     */     ;
       '10.Arial',                            /* cHTMLOPT_FONT          */     ;
       0,                                     /* nHTMLOPT_BORDER        */     ;
       'DEFAULT.CSS',                         /* cHTMLOPT_STYLE         */     ;
    }

LOCAL aOldOptions

IF Valtype( aHtmlOptions ) = 'A' .OR. Empty(aHtmlOptDefault)
  IF Valtype(aHtmlOptions) = 'A'
    aHtmlOptDefault := AClone(aHtmlOptions)
  ENDIF
  ASize(aHtmlOptDefault,nHTMLOPT_ARRAY_SIZE)
  FOR i := 1 TO nHTMLOPT_ARRAY_SIZE
    IF !(Valtype(aHtmlOptDefault[i]) == Valtype(aHtmlOptValid[i])) .AND. !(aHtmlOptValid[i]==NIL)
       aHtmlOptDefault[i] := aHtmlOptValid[i]
    ENDIF
  NEXT
  IF Valtype(aOldOptions) # 'A'
     aOldOptions := AClone(aHtmlOptDefault)
  ENDIF
ELSE
  aOldOptions := AClone(aHtmlOptDefault)
ENDIF

RETURN aOldOptions

* ---------------------

STATIC FUNCTION _VarName( aGetListItem )

LOCAL cVarName
LOCAL xVarName := aGetListItem[cGETLIST_VARNAME]
LOCAL cID := aGetListItem[cGETLIST_ID]

IF !Empty(cID)
  cVarName := cID
ELSEIF Valtype(xVarName) == 'C'
  cVarName := xVarName
ELSEIF Valtype(xVarName) == 'A'
  cVarName := xVarName[1]
ELSE
  cVarName := ''
ENDIF

cVarName := Strtran(cVarName,'->',':')

RETURN cVarName

* ---------------------

STATIC FUNCTION _FormatFont( bcFont )

LOCAL aFont

IF Valtype(bcFont) == 'B'
  bcFont := Eval(bcFont)
ENDIF

DEFAULT bcFont := ''

IF .f. // ' ' + Upper(bcFont) + ' ' $ ' VAR CITE B PRE TT H1 H2 H3 H4 H5 H6 P EM CODE Q BODY '
  aFont := { '<' + bcFont + '>', '</' + bcFont + '>' }
ELSEIF .f. // !Empty(bcFont)
  aFont := { '<Style="' + bcFont + '">', '</Font>'}
ELSE
  aFont := {'',''}
ENDIF

RETURN aFont

* --------------------

STATIC FUNCTION _TrimCols( aColumns )

LOCAL i

FOR i := Len(aColumns) TO 1 STEP -1
  IF !Empty(aColumns[i])
    EXIT
  ENDIF
NEXT

RETURN i

* ---------------

STATIC FUNCTION _TrimRows( aTable )

LOCAL i

FOR i := Len(aTable) TO 1 STEP -1
  IF _TrimCols( aTable[i] ) > 0
    EXIT
  ENDIF
NEXT

RETURN i

* --------------

STATIC FUNCTION _Caption( cCaption, xParam1, xParam2, bcToolTip, bcMessage, ;
                          aMessageInto, nElement, lQuote )

LOCAL cMessageInto, cTarget

DEFAULT lQuote := .t.

IF Valtype(cCaption) == 'A'
  cCaption := cCaption[nElement]
ENDIF

IF cCaption == NIL
  cCaption := ''
ELSEIF Valtype(cCaption) == 'B'
  cCaption := DC_XtoC(Eval(cCaption,xParam1,xParam2))
ELSEIF Valtype(cCaption) = 'C'
  cCaption := cCaption
ELSEIF !Empty(cCaption)
  cCaption := DC_XtoC(cCaption)
ELSE
  cCaption := ''
ENDIF

IF lQuote
  cCaption := Strtran(cCaption,'"','&quot;')
ENDIF

IF Valtype(bcMessage) == 'B'
  bcMessage := DC_Xtoc(Eval(bcMessage))
ENDIF

IF Valtype(bcToolTip) == 'B'
  bcToolTip := DC_Xtoc(Eval(bcToolTip))
ENDIF

IF !Empty(aMessageInto)
  cMessageInto := _GetData(aMessageInto[1])
  cTarget := _GetData(aMessageInto[2])
ENDIF

IF !Empty(bcMessage) .AND. !Empty(cMessageInto)
  bcMessage := _GetData(bcMessage)
  IF Valtype(bcMessage) == 'A'
    bcMessage := _GetData(bcMessage[1])
  ENDIF

  cCaption := ;
           '<a href="' + ;
           '/?' + cMessageInto + '=' + StrTran(bcMessage,' ','+') + '"' + ;
           IIF(!Empty(bcToolTip),' title="' + bcToolTip + '"','') + ;
           IIF(!Empty(cTarget),' target="' + cTarget + '"','') + ;
           '>' + cCaption + '</a>'
ELSEIF !Empty(bcToolTip)
  cCaption := '<a href="' + '" title="' + bcToolTip + '"' + ;
           '>' + cCaption + '</a>'
ENDIF

RETURN cCaption

* --------------

GETSETFUNCTION DC_WebServerDomainName DEFAULT "http://localhost"

* --------------

STATIC FUNCTION _TempFileName( cPath )

LOCAL  cFileName

DEFAULT cPath := ''

DO WHILE .t.

  cFileName := 'FRAME_' + StrTran( Dtos(Date())+'_'+Time(), ":", "" ) + ".HTM"

  IF !File(cPath+cFileName)
    EXIT
  ENDIF

  Sleep(100)

ENDDO

RETURN cPath + cFileName

* --------------

STATIC FUNCTION _ItemType( nType )

LOCAL cType

IF Valtype(nType) == 'B'
  nType := Eval(nType)
ENDIF

IF Valtype(nType) == 'N'
  IF nType == DCHTML_LISTITEM_UPPER
    cType := 'A'
  ELSEIF nType == DCHTML_LISTITEM_LOWER
    cType := 'a'
  ELSEIF nType == DCHTML_LISTITEM_UPPERROMAN
    cType := 'I'
  ELSEIF nType == DCHTML_LISTITEM_LOWERROMAN
    cType := 'i'
  ELSEIF nType == DCHTML_LISTITEM_ARABIC
    cType := '1'
  ELSEIF nType == DCHTML_LISTITEM_DISC
    cType := 'disc'
  ELSEIF nType == DCHTML_LISTITEM_CIRCLE
    cType := 'circle'
  ELSEIF nType == DCHTML_LISTITEM_SQUARE
    cType := 'square'
  ENDIF
ELSEIF Valtype(nType) == 'C'
    cType := nType
ENDIF

RETURN cType

* --------------

STATIC FUNCTION _GetData( xData, xParam1, xParam2 )

IF Valtype(xData) == 'B'
  xData := Eval(xData,xParam1,xParam2)
ENDIF
IF xData == nil
  RETURN ''
ELSEIF Valtype(xData) == 'A'
  RETURN xData
ENDIF

RETURN DC_XtoC(xData)

* --------------

CLASS DC_Vars

EXPORTED:

  VAR varArray

INLINE METHOD Init( aVars )

  ::varArray := {}
  IF Valtype(aVars) == 'A'
    ::varArray := AClone(aVars)
  ENDIF
  RETURN self

INLINE METHOD Add( cName, xValue )

  AAdd( ::varArray, { cName, xValue } )
  RETURN self

INLINE METHOD Get( cName )

  LOCAL nFound
  nFound := AScan(::varArray,{|a|Upper(a[1])==Upper(cName)})
  IF nFound > 0
    RETURN ::varArray[nFound,2]
  ENDIF
  RETURN nil

INLINE METHOD Delete( cName )

  LOCAL nFound
  nFound := AScan(::varArray,{|a|Upper(a[1])==Upper(cName)})
  IF nFound > 0
    ARemove(::varArray,nFound)
    RETURN .t.
  ENDIF
  RETURN .f.

ENDCLASS

* ----------------

FUNCTION DC_HtmlGetData( aVars, aField, cAlias )

LOCAL cName := aField[1], cType := aField[2]
LOCAL cData, xData, cPrefix := ''

IF !Empty(cAlias)
  cPrefix := cAlias + ':'
ENDIF

cData := DC_HtmlGetVar(aVars,cPrefix+cName,.t.)
IF cData == NIL
  RETURN NIL
ENDIF

IF cType == 'C'
  xData := cData
ELSEIF cType == 'D'
  xData := CtoD(cData)
ELSEIF cType == 'L'
  xData := Upper(cData) == 'ON'
ELSEIF cType == 'M'
  xData := cData
ELSEIF cType == 'N'
  xData := Val(cData)
ENDIF

RETURN xData

* ---------------

STATIC FUNCTION _AStuff( aElement, xValue )

IF Empty(aElement) .AND. !(xValue==NIL)
  aElement := xValue
ENDIF

RETURN nil

* ----------------

FUNCTION DC_HtmlSessionTag( cTag )

STATIC scSessionTag := ''

LOCAL cOldTag := scSessionTag
IF !Empty(cTag)
  scSessionTag := cTag
ENDIF

RETURN cOldTag

* ---------------

FUNCTION DC_HtmlGetVar( aVars, cVar, lAnyCase )

LOCAL nFound
DEFAULT lAnyCase := .f.

IF lAnyCase
  nFound := AScan( aVars, {|a|Upper(a[1])==Upper(cVar)} )
ELSE
  nFound := AScan( aVars, {|a|a[1]==cVar} )
ENDIF

IF nFound > 0
  RETURN aVars[nFound,2]
ENDIF

RETURN nil

* -----------

STATIC FUNCTION _OptionNil( acOption, cName )

LOCAL i, cString

IF acOption == nil
  RETURN ''
ELSEIF Valtype(acOption) == 'A'
  cString := ''
  FOR i := 1 TO Len(acOption)
    IF acOption[i] == nil
      RETURN ''
    ENDIF
    cString += acOption[i] + ' '
  NEXT
  IF !Empty(cString)
    cString := ' ' + cString
  ENDIF
  RETURN cString
ENDIF

RETURN ' ' + cName + '="' + _GetData( acOption ) + '"'

* -----------

STATIC FUNCTION _OptionEmpty( acOption, cName )

LOCAL i, cString

IF Empty(acOption)
  RETURN ''
ELSEIF Valtype(acOption) == 'A'
  cString := ''
  FOR i := 1 TO Len(acOption)
    cString += acOption[i] + ' '
  NEXT
  IF !Empty(cString)
    cString := ' ' + cString
  ENDIF
  RETURN cString
ENDIF

RETURN ' ' + cName + '="' + _GetData( acOption ) + '"'

* ----------

FUNCTION DC_ReadJava ( aGetList, oParent, cRootDir, oJavaMain )

LOCAL i, aJava, oJava, bBlock, nType, cJava, nPointer, ;
      xCargo, aGetListItem, oSetParent, xParent, oJavaOptions

IF oJavaMain == nil

  DEFAULT cRootDir := ''

  oJavaOptions := DC_JavaOptions():new()
  IF !Empty(cRootDir)
    oJavaOptions:rootDir := cRootDir
  ENDIF

  FOR i := 1 TO Len(aGetList)

    aGetListItem := aGetList[i]
    nType := aGetListItem[nGETLIST_TYPE]
    oParent := nil
    IF Valtype(xParent := aGetListItem[bGETLIST_PARENT]) = 'C' .AND. !(xParent[1] $ '{') // it's an ID
      oParent := DC_GetObject(aGetList,xParent)
    ELSE
      bBlock := DC_GetBlock(xParent,'O')
      IF Valtype(bBlock) = 'B'
        oParent := Eval( bBlock )
      ENDIF
    ENDIF
    IF oParent == NIL .AND. Valtype(oSetParent) = 'O'
      oParent := oSetParent
    ENDIF

    IF nType == GETLIST_JAVAMAIN
      oJava := DC_JavaMain():new( oParent, aGetListItem )
    ELSEIF nType == GETLIST_JAVASCRIPT
      oJava := DC_JavaScript():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_JAVATAG
      oJava := DC_JavaScriptTag():new(oParent, aGetListItem)
    ELSEIF nType == GETLIST_EVAL
      IF Valtype(aGetListItem[bGETLIST_WHEN]) # 'B' .OR. ;
         Eval(aGetListItem[bGETLIST_WHEN])
        Eval(aGetListItem[bGETLIST_EVAL])
      ENDIF
      LOOP
    ELSEIF nType == GETLIST_SETPARENT
      oSetParent := nil
      xParent := aGetListItem[bGETLIST_PARENT]
      IF Valtype(xParent) == 'C' .AND. !(xParent[1]=='{') // it's an ID
        oSetParent := DC_GetObject(aGetList,xParent)
      ELSE
        bBlock := DC_GetBlock(xParent,'O')
        IF Valtype( bBlock ) = 'B'
          oSetParent := Eval( bBlock )
        ENDIF
      ENDIF
      LOOP
    ELSE
      LOOP
    ENDIF

    oJava:options := oJavaOptions
    oJava:getList := aGetList
    oJava:getListPointer := i

    nPointer := aGetListItem[nGETLIST_POINTER]

    IF oJavaMain == NIL
      IF oJava:isDerivedFrom('DC_JavaMain')
        oJavaMain := oJava
      ELSE
        oJavaMain := DC_JavaMain():new()
      ENDIF
    ENDIF

    IF oParent == NIL .AND. Valtype(oJavaMain) == 'O' .AND. !(oJava:isDerivedFrom('DC_JavaMain'))
      AAdd(oJavaMain:childList,oJava)
    ENDIF

    aGetListItem[oGETLIST_OBJECT] := oJava

    bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
    IF Valtype( bBlock ) = 'B'
      Eval( bBlock, oJava )
    ENDIF

    bBlock := DC_GetBlock(aGetListItem[bGETLIST_EVAL],'O')
    IF Valtype( bBlock ) = 'B'
      Eval( bBlock, oJava )
    ENDIF

  NEXT

ENDIF

wtf aGetList, oJavaMain

cJava := oJavaMain:writeScript()

RETURN cJava

* --------------

CLASS DC_JavaOptions

EXPORTED:

  CLASS VAR rootDir
  CLASS VAR messageInto

INLINE METHOD Init()
::rootDir := DC_CurPath() + '\'

RETURN self

ENDCLASS

* ------------

CLASS DC_JavaScript

EXPORTED:

  VAR javaText
  VAR childList
  VAR parent
  VAR cargo
  VAR preText
  VAR postText
  VAR options
  VAR hideBlock
  VAR whenBlock
  VAR getList
  VAR getListPointer
  VAR _class
  VAR optionArray
  VAR source

  INLINE METHOD Init( oParent, aGetListItem )
  LOCAL xColor, aSpan

  ::childList := {}
  ::javaText := aGetListItem[cGETLIST_CAPTION]
  ::preText := aGetListItem[bGETLIST_PREEVAL]
  ::postText := aGetListItem[bGETLIST_POSTEVAL]
  ::hideBlock := aGetListItem[bGETLIST_HIDE]
  ::whenBlock := aGetListItem[bGETLIST_WHEN]
  ::_class := aGetListItem[bGETLIST_CLASS]
  ::source := aGetListItem[xGETLIST_OPTIONS2]

  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
  ENDIF

  RETURN self

  INLINE METHOD WriteScript( nLevel, xParam1, xParam2 )

  LOCAL i, cJava := '', cText, cPre, cPost
  DEFAULT nLevel := 0

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preText, xParam1, xParam2 )
  cPost := _GetData(::postText, xParam1, xParam2 )

  cJava := cPre

  FOR i := 1 TO Len(::childList)
    cJava += ::childList[i]:WriteScript( nLevel + 1 )
  NEXT

  cJava += cPost // + CRLF

  RETURN cJava

  INLINE METHOD ChildList()
  RETURN ::childList

  INLINE METHOD Status()
  RETURN 1

ENDCLASS

* ------------

CLASS DC_JavaMain FROM DC_JavaScript

EXPORTED:

  INLINE METHOD Init( oParent, aGetListItem )
  LOCAL xColor, bBlock, cPre, cPost

  IF !Empty(aGetListItem)
    ::DC_JavaScript:init( nil, aGetListItem )
  ELSE
    ::childList := {}
  ENDIF
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
  ENDIF

  RETURN self

  INLINE METHOD WriteScript( nLevel, xParam1, xParam2 )

  LOCAL i, cJava := '', cPre, cPost
  DEFAULT nLevel := 0

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preText, xParam1, xParam2 )
  cPost := _GetData(::postText, xParam1, xParam2 )

  cJava += cPre + "$(document).ready(function() {" + CRLF

  FOR i := 1 TO Len(::childList)
    cJava += ::childList[i]:writeScript( nLevel )
  NEXT

  cJava += "});" + cPost + CRLF

  RETURN cJava

ENDCLASS

* ------------

CLASS DC_JavaScriptTag FROM DC_JavaScript

EXPORTED:

  INLINE METHOD Init( oParent, aGetListItem )
  LOCAL xColor, bBlock, cPre, cPost

  IF !Empty(aGetListItem)
    ::DC_JavaScript:init( nil, aGetListItem )
  ELSE
    ::childList := {}
  ENDIF
  IF Valtype(oParent) == 'O'
    AAdd(oParent:childList,self)
  ENDIF

  RETURN self

  INLINE METHOD WriteScript( nLevel, xParam1, xParam2 )

  LOCAL i, cJava := '', cPre, cPost
  DEFAULT nLevel := 0

  IF Valtype(::hideBlock) == 'B' .AND. Eval(::hideBlock)
    RETURN ''
  ENDIF

  cPre := _GetData(::preText, xParam1, xParam2 )
  cPost := _GetData(::postText, xParam1, xParam2 )
  DEFAULT ::source := ''

  cJava += cPre + '<script type="text/javascript" src="' + ::source + '">'

  FOR i := 1 TO Len(::childList)
    cJava += ::childList[i]:writeScript( nLevel )
  NEXT

  cJava += "</script>" + cPost + CRLF

  RETURN cJava

ENDCLASS

* --------------

FUNCTION DC_Object2JS( oObject, nLevel )

LOCAL i, cText, aObject, cJS, aIvars, cIvar, xData, cCrlf

DEFAULT nLevel := 0

cJS := Space(nLevel) + '{' + CRLF

aIvars := oObject:classDescribe()[3]

FOR i := 1 TO Len(aIvars)
  cIvar := aIvars[i,1]
  xData := oObject:&(cIvar)
  cCrlf := ''
  IF Valtype(xData) = 'A'
    cCrlf := CRLF
  ENDIF
  xData := cCrlf + DC_Value2Js(xData,nLevel+1)
  cText := Space(nLevel+1) + '"' + cIvar + '": '
  cText += xData
  cJS += cText + IIF( i=Len(aIvars),'',',') + CRLF
NEXT

cJS += Space(nLevel) + '}'

RETURN cJS

* ------------

FUNCTION DC_Array2JS( aArray, nLevel )

LOCAL i, cText, xData, cCrlf

DEFAULT nLevel := 0

cText := Space(nLevel) + '[' + CRLF

FOR i := 1 TO Len(aArray)
  xData := aArray[i]
  xData := DC_Value2Js(xData,nLevel+1)
  cText += xData + IIF( i<Len(aArray),',','')  + CRLF
NEXT

cText += Space(nLevel) + ']'

RETURN cText

* -----------

FUNCTION DC_Value2Js( xData, nLevel )

LOCAL cCrLf := ''

IF Valtype( xData ) $ 'MC'
  xData := '"' + Trim(xData) + '"'
ELSEIF Valtype( xData ) == 'N'
  xData := Alltrim(Str(xData))
ELSEIF Valtype( xData ) == 'L'
  xData := IIF(xData,"true","false")
ELSEIF Valtype( xData ) == 'D'
  xData := Dtoc(xData)
ELSEIF Valtype( xData ) == 'A'
  xData := DC_Array2JS( xData, nLevel )
  RETURN xData
ELSEIF Valtype( xData ) == 'O'
  xData := DC_Object2JS( xData, nLevel )
  RETURN xData
ELSEIF xData == NIL
  xData := 'null'
ENDIF

RETURN Space(nLevel) + xData + cCrlf

* --------------

FUNCTION DC_Object2Xml( oObject, cTagName, nLevel )

LOCAL i, cText, aObject, cXml, aIvars, cIvar, xData, lArray

DEFAULT nLevel := 0, ;
        cTagName := oObject:className()

aIvars := oObject:classDescribe()[3]

cXml := Space(nLevel) + '<' + cTagName + ' type="object">' + CRLF
FOR i := 1 TO Len(aIvars)
  cIvar := aIvars[i,1]
  xData := oObject:&(cIvar)
  lArray := Valtype(xData) == 'A'
  xData := DC_Value2Xml(xData,cIvar,nLevel+1)
  cXml += xData
NEXT

cXml += Space(nLevel) + '</' + cTagName + '>'

RETURN cXml

* ------------

FUNCTION DC_Array2Xml( aArray, cTagName, nLevel )

LOCAL i, cText, xData

DEFAULT nLevel := 0, ;
        cTagName := 'array'

cText := Space(nLevel) + '<' + cTagName + ' type="array">' + CRLF

FOR i := 1 TO Len(aArray)
  xData := DC_Value2Xml(aArray[i], 'value', nLevel+1)
  cText += xData
NEXT

cText += Space(nLevel) + '</' + cTagName + '>'

RETURN cText

* -----------

FUNCTION DC_Value2Xml( xData, cTagName, nLevel )

LOCAL cType := Valtype(xData), cCrlf := ''

DEFAULT nLevel := 0

IF Valtype( xData ) $ 'MC'
  xData := '"' + Trim(xData) + '"'
ELSEIF Valtype( xData ) == 'N'
  xData := Alltrim(Str(xData))
ELSEIF Valtype( xData ) == 'L'
  xData := IIF(xData,"true","false")
ELSEIF Valtype( xData ) == 'D'
  xData := Dtoc(xData)
ELSEIF Valtype( xData ) == 'A'
  xData := DC_Array2Xml( xData, cTagName, nLevel )
  RETURN xData + CRLF
ELSEIF Valtype( xData ) == 'O'
  xData := CRLF + DC_Object2Xml( xData, xData:className(), nLevel+1 )
  cCrlf := CRLF + Space(nLevel)
ELSEIF xData == NIL
  xData := 'null'
ENDIF

RETURN Space(nLevel) + '<' + cTagName + '>' + xData + cCrlf + '</' + cTagName + '>' + CRLF




